
/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "spells.h"
#include "handler.h"
#include "db.h"
#include "map.h"

extern struct room_data *world;
extern struct obj_data *object_list;
extern struct char_data *character_list;
extern struct index_data *obj_index;

extern struct weather_data weather_info;
extern struct descriptor_data *descriptor_list;
extern struct zone_data *zone_table;

extern int mini_mud;

extern struct default_mobile_stats *mob_defaults;
extern char weapon_verbs[];
extern int *max_ac_applys;
extern struct apply_mod_defaults *apmd;

void clearMemory(struct char_data *ch);
void act(char *str, int i, struct char_data *c, struct obj_data *o,
	 void *vict_obj, int j);

void damage(struct char_data *ch, struct char_data *victim,
	    int damage, int weapontype);

void weight_change_object(struct obj_data *obj, int weight);
void add_follower(struct char_data *ch, struct char_data *leader);
int dice(int number, int size);
extern struct spell_info_type spell_info[];

struct char_data *read_mobile(int, int);
//**********Foo's Magic.c**************


//Cone of Cold
ASPELL(spell_cone_of_cold)
{
  struct char_data *target, *tar_next;
  int dam = dice(level, 4) + level;

  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (affectarea(ch, victim, loc, target, SPELL_CONE_OF_COLD))
      damage(ch, target, dam, SPELL_CONE_OF_COLD);
  }
}

//Magic Missile
ASPELL(spell_magic_missile)
{
  struct char_data *target = NULL, *tar_next = NULL;
  int i = 0, num_per = 0, dam = 0, num_spare = 0, num_hit = 0, missile_num = 0;

  missile_num = BOUNDED(1, (level - 1) / 2 + 1, 5);
#ifdef DEBUG_GRANOR
  sprintf(buf, "Missiles: %d", missile_num);
  send_to_char(buf, ch);
#endif
  if (loc) {
    for (target = world[loc->real_room].people; target; target = tar_next) {
      tar_next = target->next_in_room;
      if (affectarea(ch, victim, loc, target, SPELL_MAGIC_MISSILE)) {
	num_hit++;
      }
    }
    num_per = missile_num / ((num_hit) ? num_hit : 1);
    num_spare = missile_num - num_per * num_hit;
    for (target = world[loc->real_room].people; target; target = tar_next) {
      tar_next = target->next_in_room;
      if (affectarea(ch, victim, loc, target, SPELL_MAGIC_MISSILE)) {
	for (i = 0; i < num_per; i++) {
	  dam = dice(1, 4) + 1;
	  damage(ch, target, dam, SPELL_MAGIC_MISSILE);
#ifdef DEBUG_GRANOR
	  sprintf(buf, "Missiles Left = %d\r\n", missile_num);
	  send_to_char(buf, ch);
	  sprintf(buf, "Missile->%s\r\n", GET_NAME(target));
	  send_to_char(buf, ch);
#endif
	}
	if (num_spare) {
	  dam = dice(1, 4) + 1;
	  damage(ch, target, dam, SPELL_MAGIC_MISSILE);
#ifdef DEBUG_GRANOR
	  sprintf(buf, "Extra Missile: %s", GET_NAME(target));
	  send_to_char(buf, ch);
#endif
	  num_spare--;
	}
      }
    }
  } else {
    send_to_char("Targetted Mode\r\n", ch);
    if (affectarea(ch, victim, loc, victim, SPELL_MAGIC_MISSILE)) {
      for (; missile_num > 0; missile_num--) {
	dam = dice(1, 4) + 1;
	damage(ch, victim, dam, SPELL_MAGIC_MISSILE);
	send_to_char("Missile\r\n", ch);
      }
    }
  }
}
