/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "spells.h"
#include "handler.h"
#include "db.h"

#ifndef DEBUG_GRANOR
#define DEBUG_GRANOR 1
#endif

extern struct room_data *world;
extern struct obj_data *object_list;
extern struct char_data *character_list;
extern struct cha_app_type cha_app[];
extern struct int_app_type int_app[];
extern struct index_data *obj_index;

extern struct weather_data weather_info;
extern struct descriptor_data *descriptor_list;
extern struct zone_data *zone_table;

extern int mini_mud;

extern struct default_mobile_stats *mob_defaults;
extern char weapon_verbs[];
extern int *max_ac_applys;
extern struct apply_mod_defaults *apmd;
extern struct spell_info_type spell_info[];

void clearMemory(struct char_data *ch);
void act(char *str, int i, struct char_data *c, struct obj_data *o,
	 void *vict_obj, int j);

void damage(struct char_data *ch, struct char_data *victim,
	    int damage, int weapontype);

void weight_change_object(struct obj_data *obj, int weight);
void add_follower(struct char_data *ch, struct char_data *leader);

// Foo's Spell files

//Cone of cold
CSPELL(cast_spell_cone_of_cold)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cone_of_cold(level, ch, victim, obj, loc, savetype);
    break;
  default:
    send_to_char("Error, this is not a proper type for cone of cold", ch);
    break;
  }
}

//Magic Missile
CSPELL(cast_spell_magic_missile)
{
  send_to_char("CSPELL MAGIC MISSILE", ch);
  switch (casttype) {
  case CAST_SPELL:
    spell_magic_missile(level, ch, victim, obj, loc, savetype);
    break;
  default:
    send_to_char("Error, this is not a proper type for magic missile", ch);
    break;
  }
}
