

// hextor.spells.cleric.c
// spell calls for clerical spells
// for use with Greyhawk MUD _only_

#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "utils.h"
#include "comm.h"
#include "spells.h"
#include "handler.h"
#include "db.h"

#ifndef DEBUG_GRANOR
#define DEBUG_GRANOR 1
#endif

extern struct room_data *world;
extern struct obj_data *object_list;
extern struct char_data *character_list;
extern struct cha_app_type cha_app[];
extern struct int_app_type int_app[];
extern struct index_data *obj_index;

extern struct weather_data weather_info;
extern struct descriptor_data *descriptor_list;
extern struct zone_data *zone_table;

extern int mini_mud;

extern struct default_mobile_stats *mob_defaults;
extern char weapon_verbs[];
extern int *max_ac_applys;
extern struct apply_mod_defaults *apmd;
extern struct spell_info_type spell_info[];

void clearMemory(struct char_data *ch);
void act(char *str, int i, struct char_data *c, struct obj_data *o,
	 void *vict_obj, int j);

void damage(struct char_data *ch, struct char_data *victim,
	    int damage, int weapontype, int which, int location);

void weight_change_object(struct obj_data *obj, int weight);
void add_follower(struct char_data *ch, struct char_data *leader);

// First Level Cleric Spells
/*
   CSPELL(cast_spell_animal_friendship)
   {
   switch (casttype) {
   case CAST_SPELL:
   spell_animal_friendship(level, ch, victim, obj, loc, savetype, casttype);
   break;
   default:
   send_to_char("Error, this is not a proper type for animal friendship.", ch);
   break;
   }
   }
 */

void Error(char *ch, struct char_data *target)
{
  char *tmp = NULL;
  sprintf(tmp, "&+RError:&n _NOT_ a proper type for &+W%s&n!", ch);
  send_to_char(tmp, target);
}

CSPELL(cast_spell_invis_undead)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_invis_undead(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("invis_undead", ch);
    break;
  }
}

CSPELL(cast_spell_invis_animals)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_invis_animals(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("invis_animals", ch);
    break;
  }
}

CSPELL(cast_spell_endure_cold)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_endure_cold(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("endure_cold", ch);
    break;
  }
}

CSPELL(cast_spell_endure_heat)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_endure_heat(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("endure_heat", ch);
    break;

  }
}

CSPELL(cast_spell_pass_without_trace)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_pass_without_trace(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("pass_without_trace", ch);
    break;
  }
}

CSPELL(cast_spell_detect_charm)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_detect_charm(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("detect_charm", ch);
    break;
  }
}

CSPELL(cast_spell_undetectable_charm)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_undetectable_charm(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("undetectable_charm", ch);
    break;
  }
}

CSPELL(cast_spell_cause_fear)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_cause_fear(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("cause_fear", ch);
    break;
  }
}

CSPELL(cast_spell_remove_fear)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_remove_fear(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("remove_fear", ch);
    break;
  }
}

CSPELL(cast_spell_chant)
{
  switch (casttype) {
  case CAST_SPELL:
    spell_chant(level, ch, victim, obj, loc, savetype, casttype);
    break;
  default:
    Error("chant", ch);
    break;
  }
}
