/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#define __INTERPRETER_C__

#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "comm.h"
#include "interpreter.h"
#include "db.h"
#include "utils.h"
#include "spells.h"
#include "handler.h"
#include "mail.h"
#include "olc.h"
#include "guild.h"
#include "dg_scripts.h"
#include "sound.h"
#include "plugin.h"

extern struct grantset_struct grant_fields[];
extern struct command_info *complete_cmd_info;
extern struct zone_data *zone_table;
extern const struct title_type titles[NUM_CLASSES][LVL_IMPL + 1];
extern char *motd;
extern char *imotd;
extern char *background;
extern char *MENU;
extern char *WELC_MESSG;
extern char *START_MESSG;
extern char *NOT_OK;
extern struct char_data *character_list;
extern struct descriptor_data *descriptor_list;
extern struct player_index_element *player_table;
extern int top_of_p_table;
extern int restricted;
extern struct index_data *mob_index;
extern struct index_data *obj_index;
extern struct room_data *world;
extern void parse_guild_edit(struct descriptor_data *d, char *arg);
extern char *random_name(void);
/* external functions */
void echo_on(struct descriptor_data *d);
void echo_off(struct descriptor_data *d);
void do_start(struct char_data *ch);
void init_char(struct char_data *ch);
int create_entry(char *name);
int special(struct char_data *ch, int cmd, char *command, char *arg, int why_called);
int isbanned(char *hostname);
int Valid_Name(char *newname);
void FallingChar(struct char_data *ch, const int kill_char);
extern void sort_desc_in_list(struct descriptor_data *d);

int class_ok_race[NUM_RACES][NUM_CLASSES];

extern char *class_display[];
void oedit_parse(struct descriptor_data *d, char *arg);
void redit_parse(struct descriptor_data *d, char *arg);
void zedit_parse(struct descriptor_data *d, char *arg);
void medit_parse(struct descriptor_data *d, char *arg);
void sedit_parse(struct descriptor_data *d, char *arg);
void aedit_parse(struct descriptor_data *d, char *arg);
void qedit_parse(struct descriptor_data *d, char *arg);
void hedit_parse(struct descriptor_data *d, char *arg);
void pedit_parse(struct descriptor_data *d, char *arg);
void trigedit_parse(struct descriptor_data *d, char *arg);
void generate_desc(struct char_data *ch);
void select_terminal(struct descriptor_data *d, char *arg);
#ifdef MUDFTP
void handle_ftp_data(struct descriptor_data *, const char *);
void handle_ftp_auth(struct descriptor_data *, const char *);
void handle_ftp_command(struct descriptor_data *, const char *);
void string_write(struct descriptor_data *d, char **writeto, size_t len, long mailto, void *data);
#endif

struct command_info *complete_cmd_info = NULL;

/* prototypes for all do_x functions. */
ACMD(do_aedit);
ACMD(do_aim);
ACMD(do_alias);
ACMD(do_alert);
ACMD(do_angle);
ACMD(do_assist);
ACMD(do_at);
ACMD(do_backstab);
ACMD(do_ban);
ACMD(do_bash);
ACMD(do_buck);
ACMD(do_cast);
ACMD(do_camp);
ACMD(do_clair);
ACMD(do_climb);
ACMD(do_commands);
ACMD(do_condition);
ACMD(do_consider);
ACMD(do_connect);
ACMD(do_copyto);
ACMD(do_copyover);
ACMD(do_copym);
ACMD(do_copyo);
ACMD(do_copyr);
ACMD(do_credits);
ACMD(do_date);
ACMD(do_dc);
ACMD(do_deity);
ACMD(do_depiss);
ACMD(do_diagnose);
ACMD(do_dismount);
ACMD(do_draw);
ACMD(do_drink);
ACMD(do_drop);
ACMD(do_eat);
ACMD(do_echo);
ACMD(do_enter);
ACMD(do_equipment);
ACMD(do_examine);
ACMD(do_existance);
ACMD(do_exits);
ACMD(do_feint);
ACMD(do_flee);
ACMD(do_fly);
ACMD(do_follow);
ACMD(do_force);
ACMD(do_form);
ACMD(do_gallop);
ACMD(do_gecho);
ACMD(do_gen_comm);
ACMD(do_gen_door);
ACMD(do_gen_ps);
ACMD(do_gen_tog);
ACMD(do_gen_write);
ACMD(do_get);
ACMD(do_give);
ACMD(do_goto);
ACMD(do_grant);
ACMD(do_grab);
ACMD(do_group);
ACMD(do_gsay);
ACMD(do_hcontrol);
ACMD(do_help);
ACMD(do_hide);
ACMD(do_hit);
ACMD(do_house);
ACMD(do_info);
ACMD(do_index);
ACMD(do_inroom);
ACMD(do_introduce);
ACMD(do_inventory);
ACMD(do_invis);
ACMD(do_kick);
ACMD(do_kill);
ACMD(do_kneel);
ACMD(do_knock);
ACMD(do_last);
ACMD(do_liblist);
ACMD(do_learn);
ACMD(do_leave);
ACMD(do_legend);
ACMD(do_level);
ACMD(do_levels);
ACMD(do_levitate);
ACMD(do_load);
ACMD(do_look);
ACMD(do_lookup);
ACMD(do_loot);
ACMD(do_memorize);
ACMD(do_mlist);
ACMD(do_mount);
ACMD(do_move);
ACMD(do_money);
ACMD(do_dual);
ACMD(do_not_here);
ACMD(do_offer);
ACMD(do_olc);
ACMD(do_order);
ACMD(do_page);
ACMD(do_players);
ACMD(do_playerlog);
ACMD(do_playerlink);
ACMD(do_poofset);
ACMD(do_pour);
ACMD(do_practice);
ACMD(do_prompt);
ACMD(do_purge);
ACMD(do_push);
ACMD(do_put);
ACMD(do_qlist);
ACMD(do_qstat);
ACMD(do_quit);
ACMD(do_reload);
ACMD(do_rename);
ACMD(do_recline);
ACMD(do_remove);
ACMD(do_rent);
ACMD(do_reply);
ACMD(do_repair);
ACMD(do_repiss);
ACMD(do_report);
ACMD(do_rescue);
ACMD(do_respond);
ACMD(do_rest);
ACMD(do_restore);
ACMD(do_return);
ACMD(do_save);
ACMD(do_say);
ACMD(do_score);
ACMD(do_scribe);
ACMD(do_send);
ACMD(do_search);
ACMD(do_set);
ACMD(do_shapechange);
ACMD(do_sheathe);
ACMD(do_show);
ACMD(do_shutdown);
ACMD(do_sit);
ACMD(do_skill);
ACMD(do_skillset);
ACMD(do_sleep);
ACMD(do_sneak);
ACMD(do_snoop);
ACMD(do_speak);
ACMD(do_spec_comm);
ACMD(do_specialize);
ACMD(do_spells);
ACMD(do_spellset);
ACMD(do_split);
ACMD(do_stand);
ACMD(do_stat);
ACMD(do_steal);
ACMD(do_style);
ACMD(do_switch);
ACMD(do_swim);
ACMD(do_syslog);
ACMD(do_tame);
ACMD(do_turn);
ACMD(do_teleport);
ACMD(do_teach);
ACMD(do_terminate);
ACMD(do_testdesc);
ACMD(do_tell);
ACMD(do_time);
ACMD(do_title);
ACMD(do_toggle);
ACMD(do_trapremove);
ACMD(do_trapstat);
ACMD(do_traplist);
ACMD(do_trapset);
ACMD(do_track);
ACMD(do_trans);
ACMD(do_unban);
ACMD(do_ungroup);
ACMD(do_use);
ACMD(do_users);
ACMD(do_visible);
ACMD(do_vstat);
ACMD(do_vwear);
ACMD(do_watch);
ACMD(do_wake);
ACMD(do_wear);
ACMD(do_weather);
ACMD(do_where);
ACMD(do_who);
ACMD(do_wield);
ACMD(do_wimpy);
ACMD(do_wizlock);
ACMD(do_wiznet);
ACMD(do_wizutil);
ACMD(do_write);
ACMD(do_zonemap);
ACMD(do_zreset);
ACMD(do_guild);
ACMD(do_guildsay);
ACMD(do_god);			/* temp */

/* DG Script ACMD's */
ACMD(do_attach);
ACMD(do_detach);
ACMD(do_tlist);
ACMD(do_tstat);
ACMD(do_masound);
ACMD(do_mkill);
ACMD(do_mjunk);
ACMD(do_mdoor);
ACMD(do_mcallforguards);
ACMD(do_mechoaround);
ACMD(do_msend);
ACMD(do_mecho);
ACMD(do_mload);
ACMD(do_mpurge);
ACMD(do_mgoto);
ACMD(do_mat);
ACMD(do_mteleport);
ACMD(do_mforce);
ACMD(do_mskillset);
ACMD(do_mexp);
ACMD(do_mgold);
ACMD(do_mhunt);
ACMD(do_mremember);
ACMD(do_mforget);
ACMD(do_mtransform);

/* This is the Master Command List(tm).

 * You can put new commands in, take commands out, change the order
 * they appear in, etc.  You can adjust the "priority" of commands
 * simply by changing the order they appear in the command list.
 * (For example, if you want "as" to mean "assist" instead of "ask",
 * just put "assist" above "ask" in the Master Command List(tm).
 *
 * In general, utility commands such as "at" should have high priority;
 * infrequently used and dangerously destructive commands should have low
 * priority.
 */

const struct command_info cmd_info[] =
{
  {"RESERVED", "RESERVED", 0, 0, 0, 0},		/* this must be first -- for specprocs */

  /* directions must come before other commands but after RESERVED */
  {"north", "n", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_NORTH},
  {"east", "e", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_EAST},
  {"south", "s", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_SOUTH},
  {"west", "w", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_WEST},
  {"up", "u", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_UP},
  {"down", "d", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_DOWN},
  {"ne", "ne", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_NORTHEAST},
  {"nw", "nw", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_NORTHWEST},
  {"se", "se", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_SOUTHEAST},
  {"sw", "sw", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_SOUTHWEST},
  {"northeast", "ne", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_NORTHEAST},
  {"northwest", "nw", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_NORTHWEST},
  {"southeast", "se", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_SOUTHEAST},
  {"southwest", "sw", POS_PRONE + STAT_NORMAL, NO, do_move, 0, SCMD_SOUTHWEST},

  /* now, the main list */
  {"aedit", "aedit", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_BUILDER, SCMD_OLC_AEDIT},
  {"aim", "aim", POS_PRONE + STAT_DEAD, YES, do_aim, 0, 0},
  {"alert", "ale", POS_PRONE + STAT_SLEEPING, YES, do_alert, 0, 0},
  {"at", "at", POS_PRONE + STAT_DEAD, NO, do_at, LVL_IMMORT, 0},
  {"advance", "advan", POS_PRONE + STAT_NORMAL, YES, do_move, 0, SCMD_ADVANCE},
  {"alias", "ali", POS_PRONE + STAT_DEAD, NO, do_alias, 0, 0},
  {"angle", "ang", POS_PRONE + STAT_DEAD, YES, do_angle, 0, 0},
  {"assist", "ass", POS_STANDING + STAT_NORMAL, YES, do_assist, 0, 0},
  {"ask", "as", POS_PRONE + STAT_RESTING, NO, do_spec_comm, 0, SCMD_ASK},

  {"backstab", "back", POS_PRONE + STAT_NORMAL, NO, do_backstab, 0, 0},
  {"ban", "ban", POS_PRONE + STAT_DEAD, NO, do_ban, LVL_GRGOD, 0},
  {"balance", "bal", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"bash", "bas", POS_STANDING + STAT_NORMAL, YES, do_bash, 0, 0},
  {"buck", "buc", POS_PRONE + STAT_NORMAL, YES, do_buck, 0, 0},
  {"buy", "buy", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"bug", "bug", POS_PRONE + STAT_DEAD, YES, do_gen_write, 0, SCMD_BUG},

  {"cast", "cast", POS_SITTING + STAT_RESTING, YES, do_cast, 0, 0},
  {"camp", "cam", POS_SITTING + STAT_RESTING, NO, do_camp, 0, 0},
  {"check", "che", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"circle", "cir", POS_STANDING + STAT_NORMAL, YES, do_move, 0, SCMD_CIRCLE},
{"clairvoyance", "clair", POS_SITTING + STAT_RESTING, NO, do_clair, 0, 0},
  {"climb", "cli", POS_STANDING + STAT_NORMAL, NO, do_climb, 0, 0},
  {"clear", "cle", POS_PRONE + STAT_DEAD, YES, do_gen_ps, 0, SCMD_CLEAR},
  {"close", "clos", POS_SITTING + STAT_RESTING, YES, do_gen_door, 0, SCMD_CLOSE},
  {"cls", "cls", POS_PRONE + STAT_DEAD, YES, do_gen_ps, 0, SCMD_CLEAR},
  {"condition", "cond", POS_PRONE + STAT_DEAD, YES, do_condition, 0, 0},
  {"consider", "con", POS_PRONE + STAT_RESTING, YES, do_consider, 0, 0},
  {"connect", "connect", POS_PRONE + STAT_DEAD, NO, do_connect, LVL_GOD6, 0},
  {"copyto", "copyt", POS_PRONE + STAT_DEAD, NO, do_copyto, LVL_GOD2, 0},
  {"copym", "copym", POS_PRONE + STAT_DEAD, NO, do_copym, LVL_GOD2, 0},
  {"copyo", "copyo", POS_PRONE + STAT_DEAD, NO, do_copyo, LVL_GOD2, 0},
  {"copyr", "copyr", POS_PRONE + STAT_DEAD, NO, do_copyr, LVL_GOD2, 0},
  {"copyover", "copyover", POS_PRONE + STAT_DEAD, NO, do_copyover, LVL_IMPL, 0},
  {"commands", "comm", POS_PRONE + STAT_DEAD, NO, do_commands, 0, SCMD_COMMANDS},
  {"compact", "compa", POS_PRONE + STAT_DEAD, YES, do_gen_tog, 0, SCMD_COMPACT},
  {"credits", "cred", POS_PRONE + STAT_DEAD, NO, do_gen_ps, 0, SCMD_CREDITS},

  {"date", "dat", POS_PRONE + STAT_DEAD, NO, do_date, LVL_IMMORT, SCMD_DATE},
  {"dc", "dc", POS_PRONE + STAT_DEAD, NO, do_dc, LVL_GOD6, 0},
  {"deity", "deity", POS_PRONE + STAT_RESTING, NO, do_deity, 0, 0},
  {"depiss", "depiss", POS_PRONE + STAT_RESTING, YES, do_depiss, LVL_GOD, 0},
  {"deposit", "dep", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"diagnose", "diag", POS_PRONE + STAT_RESTING, NO, do_diagnose, 0, 0},
{"dismount", "dismount", POS_PRONE + STAT_NORMAL, YES, do_dismount, 0, 0},
  {"display", "disp", POS_PRONE + STAT_DEAD, YES, do_prompt, 0, 0},
  {"draw", "dra", POS_KNEELING + STAT_NORMAL, YES, do_get, 0, 0},
{"drink", "dri", POS_PRONE + STAT_RESTING, YES, do_drink, 0, SCMD_DRINK},
  {"drop", "dro", POS_PRONE + STAT_RESTING, YES, do_drop, 0, SCMD_DROP},

  {"eat", "ea", POS_PRONE + STAT_RESTING, YES, do_eat, 0, SCMD_EAT},
  {"echo", "echo", POS_PRONE + STAT_SLEEPING, NO, do_echo, LVL_IMMORT, SCMD_ECHO},
  {"emote", "em", POS_PRONE + STAT_RESTING, NO, do_echo, 0, SCMD_EMOTE},
  {":", ":", POS_PRONE + STAT_RESTING, NO, do_echo, 1, SCMD_EMOTE},
  {"enter", "ent", POS_PRONE + STAT_NORMAL, NO, do_enter, 0, 0},
  {"equipment", "eq", POS_PRONE + STAT_SLEEPING, YES, do_equipment, 0, 0},
  {"exits", "ex", POS_PRONE + STAT_RESTING, NO, do_exits, 0, LVL_GOD1},
  {"examine", "exa", POS_SITTING + STAT_RESTING, NO, do_examine, 0, 0},
  {"existance", "exist", POS_PRONE + STAT_RESTING, NO, do_existance, 0, LVL_GRGOD},

  {"face", "face", POS_SITTING + STAT_RESTING, YES, do_turn, 0, 0},
{"force", "forc", POS_PRONE + STAT_SLEEPING, NO, do_force, LVL_GRGOD, 0},
  {"fill", "fill", POS_PRONE + STAT_NORMAL, NO, do_pour, 0, SCMD_FILL},
  {"feint", "fe", POS_STANDING + STAT_NORMAL, YES, do_feint, 0, 0},
  {"flee", "flee", POS_STANDING + STAT_NORMAL, YES, do_flee, 0, 0},
  {"fly", "fly", POS_STANDING + STAT_NORMAL, YES, do_fly, 0, 0},
  {"follow", "fol", POS_PRONE + STAT_RESTING, NO, do_follow, 0, 0},
  {"form", "form", POS_PRONE + STAT_SLEEPING, YES, do_form, 0, 0},
  {"freeze", "free", POS_PRONE + STAT_DEAD, NO, do_wizutil, LVL_FREEZE, SCMD_FREEZE},

  {"gallop", "gal", POS_SITTING + STAT_RESTING, NO, do_gallop, 0, 0},
  {"gedit", "gedit", POS_PRONE + STAT_RESTING, NO, do_olc, LVL_BUILDER, SCMD_OLC_GEDIT},
  {"get", "ge", POS_PRONE + STAT_RESTING, NO, do_get, 0, 0},
  {"gcc", "gcc", POS_PRONE + STAT_DEAD, NO, do_guildsay, 0, 0},
  {"gecho", "gecho", POS_PRONE + STAT_DEAD, NO, do_gecho, LVL_GOD6, 0},
  {"give", "giv", POS_PRONE + STAT_RESTING, NO, do_give, 0, 0},
  {"glance", "gla", POS_PRONE + STAT_RESTING, YES, do_diagnose, 0, SCMD_GLANCE},
  {"goto", "go", POS_PRONE + STAT_SLEEPING, YES, do_goto, LVL_IMMORT, 0},
  {"god", "god", POS_PRONE + STAT_RESTING, NO, do_god, 0, 0},
  {"grant", "grant", POS_PRONE + STAT_DEAD, NO, do_grant, LVL_IMPL, 0},
  {"group", "gro", POS_PRONE + STAT_RESTING, YES, do_group, 0, 0},
  {"grab", "grab", POS_PRONE + STAT_RESTING, YES, do_grab, 0, 0},
  {"gsay", "gsa", POS_PRONE + STAT_SLEEPING, YES, do_gsay, 0, 0},
  {"gtell", "gtell", POS_PRONE + STAT_SLEEPING, YES, do_gsay, 0, 0},
  {"guild", "guild", POS_PRONE + STAT_DEAD, NO, do_guild, 0, 0},

  {"hedit", "hedit", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_BUILDER, SCMD_OLC_HEDIT},
  {"help", "hel", POS_PRONE + STAT_DEAD, YES, do_help, 0, 0},
  {"handbook", "handbook", POS_PRONE + STAT_DEAD, NO, do_gen_ps, LVL_IMMORT, SCMD_HANDBOOK},
  {"hcontrol", "hcontrol", POS_PRONE + STAT_DEAD, NO, do_hcontrol, LVL_GRGOD, 0},
  {"hide", "hide", POS_PRONE + STAT_RESTING, NO, do_hide, 0, 0},
  {"hit", "hit", POS_STANDING + STAT_NORMAL, YES, do_hit, 0, SCMD_HIT},
  {"hold", "hold", POS_PRONE + STAT_RESTING, YES, do_grab, 0, 0},
{"holler", "holl", POS_PRONE + STAT_RESTING, YES, do_say, 0, SCMD_SHOUT},
  {"house", "house", POS_PRONE + STAT_RESTING, NO, do_house, 0, 0},

  {"inventory", "i", POS_PRONE + STAT_DEAD, YES, do_inventory, 0, 0},
  {"idea", "idea", POS_PRONE + STAT_DEAD, NO, do_gen_write, 0, SCMD_IDEA},
  {"ident", "ident", POS_PRONE + STAT_DEAD, YES, do_gen_tog, LVL_GRGOD, SCMD_IDENT},
  {"imotd", "imotd", POS_PRONE + STAT_DEAD, NO, do_gen_ps, LVL_IMMORT, SCMD_IMOTD},
  {"immlist", "immlist", POS_PRONE + STAT_DEAD, NO, do_gen_ps, 0, SCMD_IMMLIST},
  {"index", "ind", POS_PRONE + STAT_RESTING, NO, do_index, LVL_IMMORT, 0},
{"info", "info", POS_PRONE + STAT_SLEEPING, NO, do_gen_ps, 0, SCMD_INFO},
{"inroom", "inro", POS_PRONE + STAT_RESTING, YES, do_inroom, LVL_GOD4, 0},
{"introduce", "intro", POS_PRONE + STAT_RESTING, YES, do_introduce, 0, 0},
  {"invis", "invis", POS_PRONE + STAT_DEAD, NO, do_invis, LVL_IMMORT, 0},
{"invoke", "invo", POS_SITTING + STAT_RESTING, YES, do_use, 1, SCMD_USE},

  {"join", "join", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"junk", "junk", POS_PRONE + STAT_RESTING, NO, do_drop, 0, SCMD_JUNK},

  {"kill", "k", POS_STANDING + STAT_NORMAL, YES, do_kill, 0, 0},
  {"kick", "kic", POS_STANDING + STAT_NORMAL, YES, do_kick, 0, 0},
  {"kneel", "kneel", POS_PRONE + STAT_RESTING, YES, do_kneel, 0, 0},
  {"knock", "knoc", POS_PRONE + STAT_RESTING, NO, do_knock, 0, 0},

  {"look", "l", POS_PRONE + STAT_RESTING, YES, do_look, 0, SCMD_LOOK},
{"lookup", "looku", POS_PRONE + STAT_DEAD, YES, do_lookup, LVL_IMMORT, 0},
  {"last", "last", POS_PRONE + STAT_DEAD, NO, do_last, LVL_GOD4, 0},
  {"learn", "learn", POS_PRONE + STAT_NORMAL, NO, do_learn, 0, 0},
  {"leave", "leave", POS_PRONE + STAT_NORMAL, NO, do_leave, 0, 0},
  {"levitate", "levit", POS_PRONE + STAT_NORMAL, YES, do_levitate, 0, 0},
  {"legend", "leg", POS_PRONE + STAT_NORMAL, YES, do_legend, 0, 0},
  {"levels", "leve", POS_PRONE + STAT_DEAD, YES, do_levels, 0, 0},
  {"level", "level", POS_PRONE + STAT_DEAD, NO, do_level, LVL_GRGOD, 0},
  {"list", "li", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"lock", "lock", POS_SITTING + STAT_RESTING, NO, do_gen_door, 0, SCMD_LOCK},
  {"loot", "loot", POS_PRONE + STAT_RESTING, NO, do_loot, 0, 0},
  {"load", "load", POS_PRONE + STAT_DEAD, YES, do_load, LVL_GOD2, 0},

  {"medit", "medit", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_GOD2, SCMD_OLC_MEDIT},
  {"memorize", "mem", POS_PRONE + STAT_RESTING, NO, do_memorize, 0, SCMD_MEM},
  {"motd", "motd", POS_PRONE + STAT_DEAD, NO, do_gen_ps, 0, SCMD_MOTD},
  {"mount", "moun", POS_PRONE + STAT_NORMAL, YES, do_mount, 0, 0},
  {"mail", "mail", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"mlist", "mlist", POS_PRONE + STAT_DEAD, NO, do_liblist, LVL_GOD2, SCMD_MLIST},
  {"dual", "dual", POS_PRONE + STAT_NORMAL, NO, do_dual, 0, 0},
  {"mute", "mute", POS_PRONE + STAT_DEAD, NO, do_wizutil, LVL_GOD4, SCMD_SQUELCH},
  {"murder", "mur", POS_STANDING + STAT_NORMAL, YES, do_hit, 0, SCMD_MURDER},
#ifdef MUDFTP
  {"mudftp", "mudftp", POS_PRONE + STAT_DEAD, NO, do_gen_tog, 0, SCMD_MUDFTP},
#endif
  {"money", "money", POS_PRONE + STAT_RESTING, NO, do_money, 0, 0},

{"news", "news", POS_PRONE + STAT_SLEEPING, YES, do_gen_ps, 0, SCMD_NEWS},
  {"nohassle", "nohassle", POS_PRONE + STAT_DEAD, NO, do_gen_tog, LVL_IMMORT, SCMD_NOHASSLE},
  {"norepeat", "norepeat", POS_PRONE + STAT_DEAD, YES, do_gen_tog, 0, SCMD_NOREPEAT},
  {"noshout", "noshout", POS_PRONE + STAT_SLEEPING, YES, do_gen_tog, 1, SCMD_DEAF},
  {"notell", "notell", POS_PRONE + STAT_DEAD, YES, do_gen_tog, 1, SCMD_NOTELL},
  {"notitle", "notitle", POS_PRONE + STAT_DEAD, NO, do_wizutil, LVL_GOD6, SCMD_NOTITLE},
  {"nowiz", "nowiz", POS_PRONE + STAT_DEAD, NO, do_gen_tog, LVL_IMMORT, SCMD_NOWIZ},

  {"order", "o", POS_PRONE + STAT_RESTING, YES, do_order, 0, 0},
  {"offer", "off", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"open", "op", POS_SITTING + STAT_RESTING, YES, do_gen_door, 0, SCMD_OPEN},
  {"olc", "olc", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_GOD2, SCMD_OLC_SAVEINFO},
  {"oedit", "oedit", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_GOD2, SCMD_OLC_OEDIT},
  {"olist", "olist", POS_PRONE + STAT_DEAD, NO, do_liblist, LVL_GOD2, SCMD_OLIST},

  {"put", "put", POS_PRONE + STAT_RESTING, NO, do_put, 0, 0},
  {"page", "page", POS_PRONE + STAT_DEAD, NO, do_page, LVL_GOD1, 0},
  {"paging", "paging", POS_PRONE + STAT_DEAD, NO, do_gen_tog, 0, SCMD_PAGING},
  {"pardon", "pard", POS_PRONE + STAT_DEAD, NO, do_wizutil, LVL_GOD4, SCMD_PARDON},
  {"petition", "peti", POS_PRONE + STAT_RESTING, YES, do_gen_comm, 0, SCMD_PETITION},
  {"ptell", "pt", POS_PRONE + STAT_RESTING, YES, do_tell, 0, SCMD_PTELL},
{"pick", "pick", POS_PRONE + STAT_NORMAL, NO, do_gen_door, 1, SCMD_PICK},
{"players", "player", POS_PRONE + STAT_DEAD, NO, do_players, LVL_GOD4, 0},
  {"playerlog", "playerlog", POS_PRONE + STAT_DEAD, NO, do_playerlog, LVL_GOD4, 0},
  {"playerlink", "playerlink", POS_PRONE + STAT_DEAD, NO, do_playerlink, LVL_GOD6, 0},
  {"policy", "policy", POS_PRONE + STAT_DEAD, NO, do_gen_ps, 0, SCMD_POLICIES},
  {"poofin", "poofin", POS_PRONE + STAT_DEAD, NO, do_poofset, LVL_IMMORT, SCMD_POOFIN},
  {"poofout", "poofout", POS_PRONE + STAT_DEAD, NO, do_poofset, LVL_IMMORT, SCMD_POOFOUT},
  {"pour", "pour", POS_PRONE + STAT_NORMAL, NO, do_pour, 0, SCMD_POUR},
{"pray", "pra", POS_PRONE + STAT_RESTING, NO, do_memorize, 0, SCMD_PRAY},
  {"prompt", "prompt", POS_PRONE + STAT_DEAD, YES, do_prompt, 0, 0},
  {"practice", "prac", POS_PRONE + STAT_RESTING, NO, do_practice, 0, 0},
  {"pummel", "pumm", POS_PRONE + STAT_DEAD, NO, do_gen_tog, LVL_IMMORT, SCMD_PUMMEL},
  {"purge", "purge", POS_PRONE + STAT_DEAD, YES, do_purge, LVL_GOD2, 0},
  {"push", "push", POS_STANDING + STAT_NORMAL, NO, do_push, 0, 0},

  {"quaff", "quaf", POS_PRONE + STAT_RESTING, YES, do_use, 0, SCMD_QUAFF},
  {"qedit", "qedit", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_BUILDER, SCMD_OLC_QEDIT},
  {"qlist", "qlist", POS_PRONE + STAT_DEAD, NO, do_qlist, LVL_IMMORT, 0},
  {"qstat", "qstat", POS_PRONE + STAT_DEAD, NO, do_qstat, LVL_IMMORT, 0},
  {"qui", "qui", POS_PRONE + STAT_DEAD, NO, do_quit, 0, 0},
  {"quit", "quit", POS_PRONE + STAT_DEAD, NO, do_quit, 0, SCMD_QUIT},

  {"reboot", "reboot", POS_PRONE + STAT_DEAD, NO, do_shutdown, LVL_GOD6, SCMD_REBOOT},
  {"repiss", "repiss", POS_PRONE + STAT_RESTING, YES, do_repiss, LVL_GOD, 0},
  {"reply", "reply", POS_PRONE + STAT_SLEEPING, YES, do_reply, 0, 0},
  {"rest", "re", POS_PRONE + STAT_RESTING, YES, do_rest, 0, 0},
  {"respond", "respond", POS_PRONE + STAT_RESTING, NO, do_respond, 0, 0},
  {"read", "read", POS_PRONE + STAT_RESTING, NO, do_look, 0, SCMD_READ},
  {"reload", "reload", POS_PRONE + STAT_DEAD, NO, do_reload, LVL_GOD7, 0},
  {"rename", "rename", POS_PRONE + STAT_DEAD, NO, do_rename, LVL_GOD6, 0},
  {"recite", "recite", POS_PRONE + STAT_RESTING, NO, do_use, 0, SCMD_RECITE},
  {"receive", "recei", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"recline", "recli", POS_PRONE + STAT_RESTING, NO, do_recline, 0, 0},
  {"remove", "rem", POS_SITTING + STAT_RESTING, NO, do_remove, 0, 0},
  {"rent", "ren", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"report", "rep", POS_PRONE + STAT_RESTING, YES, do_report, 0, 0},
  {"repair", "repa", POS_STANDING + STAT_NORMAL, NO, do_repair, 0, 0},
  {"reroll", "reroll", POS_PRONE + STAT_DEAD, NO, do_wizutil, LVL_GRGOD, SCMD_REROLL},
  {"rescue", "resc", POS_STANDING + STAT_NORMAL, YES, do_rescue, 0, 0},
  {"reset", "rese", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"restore", "restor", POS_PRONE + STAT_DEAD, YES, do_restore, LVL_GOD4, 0},
  {"retreat", "ret", POS_STANDING + STAT_NORMAL, YES, do_move, 0, SCMD_RETREAT},
  {"return", "return", POS_PRONE + STAT_DEAD, YES, do_return, 0, 0},
  {"redit", "redit", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_BUILDER, SCMD_OLC_REDIT},
{"roll", "roll", POS_STANDING + STAT_NORMAL, YES, do_move, 0, SCMD_ROLL},
  {"rlist", "rlist", POS_PRONE + STAT_DEAD, NO, do_liblist, LVL_GOD2, SCMD_RLIST},

  {"say", "sa", POS_PRONE + STAT_RESTING, YES, do_say, 0, 0},
  {"'", "'", POS_PRONE + STAT_RESTING, YES, do_say, 0, 0},
  {"save", "sav", POS_PRONE + STAT_SLEEPING, YES, do_save, 0, 0},
  {"score", "sc", POS_PRONE + STAT_DEAD, YES, do_score, 0, 0},
  {"scribe", "scr", POS_PRONE + STAT_RESTING, NO, do_scribe, 0, 0},
  {"sell", "sell", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"search", "sea", POS_PRONE + STAT_NORMAL, NO, do_search, 0, 0},
  {"send", "send", POS_PRONE + STAT_SLEEPING, NO, do_send, LVL_GOD4, 0},
  {"set", "set", POS_PRONE + STAT_DEAD, NO, do_set, LVL_GOD2, 0},
  {"sedit", "sedit", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_GOD2, SCMD_OLC_SEDIT},
  {"sheathe", "she", POS_STANDING + STAT_NORMAL, YES, do_put, 0, 0},
  {"shout", "shou", POS_PRONE + STAT_RESTING, YES, do_say, 0, SCMD_SHOUT},
  {"shapem", "shapem", POS_PRONE + STAT_DEAD, NO, do_shapechange, 0, SCMD_MOB},
  {"shapeo", "shapeo", POS_PRONE + STAT_DEAD, NO, do_shapechange, 0, SCMD_OBJ},
  {"show", "sho", POS_PRONE + STAT_DEAD, NO, do_show, 0, 0},
  {"shutdow", "shutdow", POS_PRONE + STAT_DEAD, NO, do_shutdown, LVL_IMPL, 0},
  {"shutdown", "shutdown", POS_PRONE + STAT_DEAD, NO, do_shutdown, LVL_IMPL, SCMD_SHUTDOWN},
  {"sip", "sip", POS_PRONE + STAT_RESTING, YES, do_drink, 0, SCMD_SIP},
  {"sit", "sit", POS_PRONE + STAT_RESTING, YES, do_sit, 0, 0},
  {"skill", "skill", POS_PRONE + STAT_SLEEPING, NO, do_skill, 0, 0},
  {"skillset", "skillset", POS_PRONE + STAT_SLEEPING, NO, do_skillset, LVL_GRGOD, 0},
  {"sleep", "sleep", POS_PRONE + STAT_SLEEPING, NO, do_sleep, 0, 0},
  {"slist", "slist", POS_PRONE + STAT_DEAD, NO, do_liblist, LVL_GOD2, SCMD_SLIST},
  {"slowns", "slowns", POS_PRONE + STAT_DEAD, NO, do_gen_tog, LVL_IMPL, SCMD_SLOWNS},
  {"sneak", "snea", POS_PRONE + STAT_NORMAL, NO, do_sneak, 0, 0},
  {"snoop", "snoop", POS_PRONE + STAT_DEAD, NO, do_snoop, LVL_GOD6, 0},
  {"socials", "social", POS_PRONE + STAT_DEAD, NO, do_commands, 0, SCMD_SOCIALS},
  {"speak", "spe", POS_PRONE + STAT_DEAD, YES, do_speak, 0, 0},
  {"split", "split", POS_SITTING + STAT_RESTING, NO, do_split, 0, 0},
  {"specialize", "specialize", POS_PRONE + STAT_RESTING, NO, do_specialize, 0, 0},
  {"spells", "spells", POS_PRONE + STAT_RESTING, YES, do_spells, 0, 0},
  {"spellset", "spellset", POS_PRONE + STAT_SLEEPING, NO, do_spellset, LVL_GRGOD, 0},
  {"stand", "st", POS_PRONE + STAT_RESTING, YES, do_stand, 0, 0},
  {"stat", "stat", POS_PRONE + STAT_DEAD, YES, do_stat, LVL_IMMORT, 0},
  {"steal", "steal", POS_PRONE + STAT_NORMAL, NO, do_steal, 0, 0},
  {"style", "sty", POS_PRONE + STAT_DEAD, YES, do_style, 0, 0},
  {"switch", "switch", POS_PRONE + STAT_DEAD, YES, do_switch, LVL_BUILDER, 0},
  {"swim", "swim", POS_PRONE + STAT_DEAD, NO, do_swim, 0, 0},
{"syslog", "syslog", POS_PRONE + STAT_DEAD, NO, do_syslog, LVL_IMMORT, 0},

  {"tell", "t", POS_PRONE + STAT_DEAD, YES, do_tell, 0, 0},
  {"teach", "teac", POS_PRONE + STAT_RESTING, NO, do_teach, 0, 0},

  {"testdesc", "testdes", POS_PRONE + STAT_DEAD, NO, do_testdesc, LVL_GRGOD, 0},
  {"take", "take", POS_PRONE + STAT_RESTING, NO, do_get, 0, 0},
  {"tame", "tame", POS_PRONE + STAT_NORMAL, NO, do_tame, 0, 0},
{"taste", "taste", POS_PRONE + STAT_RESTING, YES, do_eat, 0, SCMD_TASTE},
{"teleport", "tele", POS_PRONE + STAT_DEAD, NO, do_teleport, LVL_GOD4, 0},
  {"terminate", "term", POS_PRONE + STAT_DEAD, YES, do_terminate, LVL_IMPL, 0},
  {"thaw", "thaw", POS_PRONE + STAT_DEAD, NO, do_wizutil, LVL_FREEZE, SCMD_THAW},
  {"title", "tit", POS_PRONE + STAT_DEAD, NO, do_title, LVL_IMMORT, 0},
  {"time", "ti", POS_PRONE + STAT_DEAD, NO, do_time, 0, 0},
  {"toggle", "tog", POS_PRONE + STAT_DEAD, YES, do_toggle, 0, 0},
  {"trapremove", "trapremove", POS_PRONE + STAT_NORMAL, NO, do_trapremove, LVL_GOD1, 0},
  {"trapstat", "trapstat", POS_PRONE + STAT_NORMAL, NO, do_trapstat, LVL_GOD1, 0},
  {"traplist", "traplist", POS_PRONE + STAT_NORMAL, NO, do_traplist, LVL_GOD1, 0},
  {"trapset", "trapset", POS_PRONE + STAT_NORMAL, NO, do_trapset, LVL_GOD1, 0},
  {"track", "track", POS_PRONE + STAT_NORMAL, NO, do_track, 0, 0},
  {"transfer", "trans", POS_PRONE + STAT_SLEEPING, NO, do_trans, LVL_GOD4, 0},
  {"tedit", "tedit", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_BUILDER, SCMD_OLC_TEDIT},
  {"trusted", "trust", POS_PRONE + STAT_DEAD, YES, do_gen_tog, LVL_IMMORT, SCMD_HOLYLIGHT},
  {"typo", "typo", POS_PRONE + STAT_DEAD, NO, do_gen_write, 0, SCMD_TYPO},
  {"turn", "tur", POS_SITTING + STAT_RESTING, YES, do_turn, 0, 0},

  {"unlock", "unl", POS_SITTING + STAT_RESTING, NO, do_gen_door, 0, SCMD_UNLOCK},
  {"ungroup", "ung", POS_PRONE + STAT_DEAD, NO, do_ungroup, 0, 0},
  {"unban", "unban", POS_PRONE + STAT_DEAD, NO, do_unban, LVL_GRGOD, 0},
  {"unaffect", "unnaffect", POS_PRONE + STAT_DEAD, NO, do_wizutil, LVL_GOD5, SCMD_UNAFFECT},
  {"uptime", "uptime", POS_PRONE + STAT_DEAD, NO, do_date, LVL_IMMORT, SCMD_UPTIME},
  {"use", "use", POS_SITTING + STAT_RESTING, YES, do_use, 1, SCMD_USE},
  {"users", "user", POS_PRONE + STAT_DEAD, NO, do_users, LVL_IMMORT, 0},

  {"value", "value", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"visible", "vis", POS_PRONE + STAT_RESTING, YES, do_visible, 0, 0},
  {"vnum", "vnum", POS_PRONE + STAT_DEAD, NO, do_gen_tog, LVL_IMMORT, SCMD_ROOMFLAGS},
  {"vstat", "vstat", POS_PRONE + STAT_DEAD, NO, do_vstat, LVL_IMMORT, 0},
  {"vwear", "vwear", POS_PRONE + STAT_DEAD, NO, do_vwear, LVL_BUILDER, 0},

  {"wake", "wak", POS_PRONE + STAT_SLEEPING, YES, do_wake, 0, 0},
  {"want", "want", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"watch", "wat", POS_PRONE + STAT_RESTING, NO, do_watch, 0, 0},
  {"wear", "wea", POS_PRONE + STAT_RESTING, NO, do_wear, 0, 0},
  {"weather", "weat", POS_PRONE + STAT_RESTING, YES, do_weather, 0, 0},
  {"who", "wh", POS_PRONE + STAT_DEAD, NO, do_who, 0, 0},
  {"whoami", "whoami", POS_PRONE + STAT_DEAD, YES, do_gen_ps, 0, SCMD_WHOAMI},
  {"where", "where", POS_PRONE + STAT_RESTING, NO, do_where, LVL_GOD1, 0},
  {"whisper", "whisp", POS_PRONE + STAT_RESTING, NO, do_spec_comm, 0, SCMD_WHISPER},
  {"wield", "wi", POS_PRONE + STAT_RESTING, YES, do_wield, 0, 0},
  {"wimpy", "wimp", POS_PRONE + STAT_DEAD, YES, do_wimpy, 0, 0},
  {"withdraw", "with", POS_PRONE + STAT_NORMAL, NO, do_not_here, 0, 0},
  {"wiznet", "wiz", POS_PRONE + STAT_DEAD, YES, do_wiznet, LVL_IMMORT, 0},
  {"wizmessage", "wiz", POS_PRONE + STAT_DEAD, YES, do_wiznet, LVL_IMMORT, 0},
  {";", ";", POS_PRONE + STAT_DEAD, YES, do_wiznet, LVL_IMMORT, 0},
  {"wizhelp", "wizh", POS_PRONE + STAT_SLEEPING, NO, do_commands, LVL_IMMORT, SCMD_WIZHELP},
  {"wizlist", "wizl", POS_PRONE + STAT_DEAD, NO, do_gen_ps, 0, SCMD_WIZLIST},
  {"wizlock", "wizlock", POS_PRONE + STAT_DEAD, NO, do_wizlock, LVL_IMPL, 0},
  {"write", "write", POS_PRONE + STAT_NORMAL, NO, do_write, 0, 0},

  {"yell", "yell", POS_PRONE + STAT_RESTING, YES, do_say, 0, SCMD_SHOUT},

  {"zedit", "zedit", POS_PRONE + STAT_DEAD, NO, do_olc, LVL_BUILDER, SCMD_OLC_ZEDIT},
  {"zonemap", "zonem", POS_PRONE + STAT_DEAD, NO, do_zonemap, 0, 0},
  {"zreset", "zreset", POS_PRONE + STAT_DEAD, NO, do_zreset, LVL_GOD2, 0},

   /* DG trigger commands */
  {"attach", "attach", POS_PRONE + STAT_DEAD, NO, do_attach, LVL_GOD6, 0},
  {"detach", "detach", POS_PRONE + STAT_DEAD, NO, do_detach, LVL_GOD6, 0},
  {"tlist", "tlist", POS_PRONE + STAT_DEAD, NO, do_tlist, LVL_GOD2, 0},
  {"tstat", "tstat", POS_PRONE + STAT_DEAD, NO, do_tstat, LVL_GOD2, 0},
  {"mdoor", "mdoor", POS_PRONE + STAT_DEAD, NO, do_masound, -1, 0},
  {"masound", "masound", POS_PRONE + STAT_DEAD, NO, do_masound, -1, 0},
  {"mkill", "mkill", POS_STANDING + STAT_NORMAL, YES, do_mkill, -1, 0},
  {"mjunk", "mjunk", POS_SITTING + STAT_RESTING, YES, do_mjunk, -1, 0},
  {"mechoaround", "mechoaround", POS_PRONE + STAT_DEAD, YES, do_mechoaround, -1, 0},
  {"msend", "msend", POS_PRONE + STAT_DEAD, YES, do_msend, -1, 0},
  {"mecho", "mecho", POS_PRONE + STAT_DEAD, YES, do_mecho, -1, 0},
  {"mload", "mload", POS_PRONE + STAT_DEAD, YES, do_mload, -1, 0},
  {"mpurge", "mpurge", POS_PRONE + STAT_DEAD, YES, do_mpurge, -1, 0},
  {"mgoto", "mgoto", POS_PRONE + STAT_DEAD, YES, do_mgoto, -1, 0},
  {"mat", "mat", POS_PRONE + STAT_DEAD, YES, do_mat, -1, 0},
  {"mteleport", "mteleport", POS_PRONE + STAT_DEAD, YES, do_mteleport, -1, 0},
  {"mforce", "mforce", POS_PRONE + STAT_DEAD, YES, do_mforce, -1, 0},
  {"mskillset", "mskillset", POS_SITTING + STAT_RESTING, NO, do_mskillset, -1, SCMD_SKILLSET},
  {"mteach", "mteach", POS_SITTING + STAT_RESTING, NO, do_mskillset, -1, SCMD_TEACH},
  {"mcallforguards", "mcallforguards", POS_PRONE + STAT_DEAD, YES, do_mcallforguards, -1, 0},
  {"mexp", "mexp", POS_PRONE + STAT_DEAD, YES, do_mexp, -1, 0},
  {"mgold", "mgold", POS_PRONE + STAT_DEAD, YES, do_mgold, -1, 0},
  {"mhunt", "mhunt", POS_PRONE + STAT_DEAD, YES, do_mhunt, -1, 0},
  {"mremember", "mremember", POS_PRONE + STAT_DEAD, YES, do_mremember, -1, 0},
  {"mforget", "mforget", POS_PRONE + STAT_DEAD, YES, do_mforget, -1, 0},
  {"mtransform", "mtransform", POS_PRONE + STAT_DEAD, YES, do_mtransform, -1, 0},

  {"\n", 0, 0, 0, 0}};		/* this must be last */

char *fill[] =
{
  "in",
  "from",
  "with",
  "the",
  "on",
  "at",
  "to",
  "\n"
};

char *reserved[] =
{
  "a",
  "an",
  "self",
  "me",
  "all",
  "new",
  "room",
  "someone",
  "something",
  "\n"
};

/*
 * This is the actual command interpreter called from game_loop() in comm.c
 * It makes sure you are the proper level and position to execute the command,
 * then calls the appropriate function.
 */
void command_interpreter(struct char_data *ch, char *argument)
{
  int cmd, length, l, found = 0;
  extern int no_specials;
  char *line;
  char *ch_ptr;

  if (IS_NPC(ch) && GET_MOB_WAIT(ch))
    return;
  if (IS_PC(ch) && CHECK_WAIT(ch))
    return;

  /* just drop to next line for hitting CR */
  skip_spaces(&argument);
  if (!*argument)
    return;

  REMOVE_BIT(AFF_FLAGS(ch), AFF_HIDE);

  /*
   * special case to handle one-character, non-alphanumeric commands;
   * requested by many people so "'hi" or ";godnet test" is possible.
   */
  if (!isalpha(*argument) && !isdigit(*argument)) {
    arg[0] = argument[0];
    arg[1] = '\0';
    line = argument + 1;
  } else {
    arg[0] = '\0';
    line = any_one_arg(argument, arg);
  }

  /* otherwise, find the command */

  if (!IS_TRUSTED(ch)) {
    int cont;			/* continue the command checks */
    cont = command_wtrigger(ch, arg, line);
    if (!cont)
      cont += command_mtrigger(ch, arg, line);
    if (!cont)
      cont = command_otrigger(ch, arg, line);
    if (cont)
      return;			/* command trigger took over */
  }
  //search command list for exact command
  for (length = strlen(arg), cmd = 0; *complete_cmd_info[cmd].command != '\n'; cmd++)
    if (!strcmp(complete_cmd_info[cmd].command, arg) || !strcmp(complete_cmd_info[cmd].sort_as, arg)) {
      found = 1;
      if (GET_LEVEL(ch) >= complete_cmd_info[cmd].minimum_level)
	break;
      /* maybe its a granted command */
      else {
	for (l = 0; *(grant_fields[l].cmd) != '\n'; l++)
	  if (!strncmp(grant_fields[l].cmd, arg, length))	/* it is grantable */
	    if ((grant_fields[l].bit <= BIT_32 && IS_SET(GRANT_FLAGS(ch), grant_fields[l].bit)) ||
		(grant_fields[l].bit > BIT_32 && IS_SET(GRANT2_FLAGS(ch), grant_fields[l].bit)))
	      break;
      }				//else
      /* end of grant checks */
    }				//if

  //search command list for partial commmands
  if (!found)
    for (length = strlen(arg), cmd = 0; *complete_cmd_info[cmd].command != '\n'; cmd++)
      if (!strncmp(complete_cmd_info[cmd].command, arg, length)) {
	if (GET_LEVEL(ch) >= complete_cmd_info[cmd].minimum_level)
	  break;
	/* maybe its a granted command */
	else {
	  for (l = 0; *(grant_fields[l].cmd) != '\n'; l++)
	    if (!strncmp(grant_fields[l].cmd, arg, length))	/* it is grantable */
	      if ((grant_fields[l].bit <= BIT_32 && IS_SET(GRANT_FLAGS(ch), grant_fields[l].bit)) ||
		  (grant_fields[l].bit > BIT_32 && IS_SET(GRANT2_FLAGS(ch), grant_fields[l].bit)))
		break;
	}			//else
	/* end of grant checks */
      }				//if


  if (*complete_cmd_info[cmd].command == '\n') {
    send_to_char(NOT_OK, ch);
    return;
  } else if (PLR_FLAGGED(ch, PLR_FROZEN) && GET_LEVEL(ch) < LVL_IMPL) {
    send_to_char("You try, but the mind-numbing cold prevents you...\r\n", ch);
    return;
  } else if (complete_cmd_info[cmd].command_pointer == NULL) {
    send_to_char("Sorry, that command hasn't been implemented yet.\r\n", ch);
    return;
  } else if (IS_NPC(ch) && complete_cmd_info[cmd].minimum_level >= LVL_IMMORT) {
    send_to_char("You can't use immortal commands while switched.\r\n", ch);
    return;
  } else if (IS_AFFECTED4(ch, AFF4_KNOCKED_OUT)) {
    if ((STAT_MASK & complete_cmd_info[cmd].minimum_position) != STAT_DEAD) {
      send_to_char("Being knocked unconscious strictly limits what you can do.\r\n", ch);
      return;
    }
    return;
  }
  if (!IS_TRUSTED(ch) && !IS_NPC(ch)) {
    for (ch_ptr = argument; *ch_ptr != '\0'; ch_ptr++) {
      if (*ch_ptr == '&')
	switch (*(ch_ptr + 1)) {
	case '+':
	case '-':
	case '=':
	case 'n':
	case 'N':
	  send_to_char("Pardon? No ansi chars allowed as input.\r\n", ch);
	  return;
	}
    }
  }
  if (!IS_TRUSTED(ch)) {
    for (ch_ptr = argument; *ch_ptr != '\0'; ch_ptr++) {
      if (*ch_ptr == '!')
	if (*(ch_ptr + 1) == '!')
	  if (isupper(*(ch_ptr + 2))) {
	    send_to_char("Pardon? No sound sequences allowed as input.\r\n", ch);
	    return;
	  }
    }
  }
  if (CMD_IS("petition") || CMD_IS("peti")) {
    ((*complete_cmd_info[cmd].command_pointer) (ch, line, cmd, complete_cmd_info[cmd].subcmd));
    return;
  }				//if

  if (!MIN_POS(ch, complete_cmd_info[cmd].minimum_position) ||
      (FIGHTING(ch) && !complete_cmd_info[cmd].in_battle)) {
    if (GET_STAT(ch) < (complete_cmd_info[cmd].minimum_position & STAT_MASK))
      switch (GET_STAT(ch)) {
      case STAT_DEAD:
	send_to_char("Lie still; you are DEAD!!!\r\n", ch);
	return;
      case STAT_INCAP:
      case STAT_DYING:
	send_to_char("You are in pretty bad shape, unable to do anything!\r\n", ch);
	return;
      case STAT_SLEEPING:
	send_to_char("In your dreams, or what?\r\n", ch);
	return;
      case STAT_RESTING:
	send_to_char("Nah... You feel too relaxed to do that...\r\n", ch);
	return;
      }
  } else if (GET_POS(ch) < (complete_cmd_info[cmd].minimum_position & 3)) {
    switch (GET_POS(ch)) {
    case POS_PRONE:
      send_to_char("Sorry, you can't do that while laying around.\r\n", ch);
      return;
    case POS_KNEELING:
      send_to_char("Maybe you should get up off your knees first?\r\n", ch);
      return;
    case POS_SITTING:
      send_to_char("Maybe you should get on your feet first?\r\n", ch);
      return;
    }
  }
  if (IS_FIGHTING(ch) && !complete_cmd_info[cmd].in_battle) {
    send_to_char("Sorry, you aren't allowed to do that in combat.\r\n", ch);
    return;
  }
  /* limited use commands here */
  if (CHAR_POLYMORPH_OBJ(ch) &&	/* !IS_TRUSTED(ch) && */
      complete_cmd_info[cmd].subcmd != SCMD_OBJ &&
      complete_cmd_info[cmd].subcmd != SCMD_PETITION &&
      complete_cmd_info[cmd].subcmd != SCMD_LOOK) {
    send_to_char("Not in this form, you can't.\r\n", ch);
    return;
  }
  if (no_specials || !special(ch, cmd, arg, line, PROC_NORMAL))
    ((*complete_cmd_info[cmd].command_pointer) (ch, line, cmd, complete_cmd_info[cmd].subcmd));
}

/**************************************************************************
 * Routines to handle aliasing                                             *
  **************************************************************************/


struct alias *find_alias(struct alias *alias_list, char *str)
{
  while (alias_list != NULL) {
    if (*str == *alias_list->alias)	/* hey, every little bit counts :-) */
      if (!strcmp(str, alias_list->alias))
	return alias_list;

    alias_list = alias_list->next;
  }

  return NULL;
}


void free_alias(struct alias *a)
{
  if (a->alias)
    FREE(a->alias);
  if (a->replacement)
    FREE(a->replacement);
  FREE(a);
}


/* The interface to the outside world: do_alias */
ACMD(do_alias)
{
  char *repl;
  struct alias *a, *temp;

  if (IS_NPC(ch))
    return;

  return;			/* taken out, I like zmud better */

  repl = any_one_arg(argument, arg);

  if (!*arg) {			/* no argument specified -- list currently defined aliases */
    send_to_char("Currently defined aliases:\r\n", ch);
    if ((a = GET_ALIASES(ch)) == NULL)
      send_to_char(" None.\r\n", ch);
    else {
      while (a != NULL) {
	sprintf(buf, "%-15s %s\r\n", a->alias, a->replacement);
	send_to_char(buf, ch);
	a = a->next;
      }
    }
  } else {			/* otherwise, add or remove aliases */
    /* is this an alias we've already defined? */
    if ((a = find_alias(GET_ALIASES(ch), arg)) != NULL) {
      REMOVE_FROM_LIST(a, GET_ALIASES(ch), next);
      free_alias(a);
    }
    /* if no replacement string is specified, assume we want to delete */
    if (!*repl) {
      if (a == NULL)
	send_to_char("No such alias.\r\n", ch);
      else
	send_to_char("Alias deleted.\r\n", ch);
    } else {			/* otherwise, either add or redefine an alias */
      if (!str_cmp(arg, "alias")) {
	send_to_char("You can't alias 'alias'.\r\n", ch);
	return;
      }
      CREATE(a, struct alias, 1);
      a->alias = str_dup(arg);
      delete_doubledollar(repl);
      a->replacement = str_dup(repl);
      if (strchr(repl, ALIAS_SEP_CHAR) || strchr(repl, ALIAS_VAR_CHAR))
	a->type = ALIAS_COMPLEX;
      else
	a->type = ALIAS_SIMPLE;
      a->next = GET_ALIASES(ch);
      GET_ALIASES(ch) = a;
      send_to_char("Alias added.\r\n", ch);
    }
  }
}

/*
 * Valid numeric replacements are only $1 .. $9 (makes parsing a little
 * easier, and it's not that much of a limitation anyway.)  Also valid
 * is "$*", which stands for the entire original line after the alias.
 * ";" is used to delimit commands.
 */
#define NUM_TOKENS       9

void perform_complex_alias(struct txt_q *input_q, char *orig, struct alias *a)
{
  struct txt_q temp_queue;
  char *tokens[NUM_TOKENS], *temp, *write_point;
  int num_of_tokens = 0, num;

  /* First, parse the original string */
  temp = strtok(strcpy(buf2, orig), " ");
  while (temp != NULL && num_of_tokens < NUM_TOKENS) {
    tokens[num_of_tokens++] = temp;
    temp = strtok(NULL, " ");
  }

  /* initialize */
  write_point = buf;
  temp_queue.head = temp_queue.tail = NULL;

  /* now parse the alias */
  for (temp = a->replacement; *temp; temp++) {
    if (*temp == ALIAS_SEP_CHAR) {
      *write_point = '\0';
      buf[MAX_INPUT_LENGTH - 1] = '\0';
      write_to_q(buf, &temp_queue, 1);
      write_point = buf;
    } else if (*temp == ALIAS_VAR_CHAR) {
      temp++;
      if ((num = *temp - '1') < num_of_tokens && num >= 0) {
	strcpy(write_point, tokens[num]);
	write_point += strlen(tokens[num]);
      } else if (*temp == ALIAS_GLOB_CHAR) {
	strcpy(write_point, orig);
	write_point += strlen(orig);
      } else if ((*(write_point++) = *temp) == '$')	/* redouble $ for act safety */
	*(write_point++) = '$';
    } else
      *(write_point++) = *temp;
  }

  *write_point = '\0';
  buf[MAX_INPUT_LENGTH - 1] = '\0';
  write_to_q(buf, &temp_queue, 1);

  /* push our temp_queue on to the _front_ of the input queue */
  if (input_q->head == NULL)
    *input_q = temp_queue;
  else {
    temp_queue.tail->next = input_q->head;
    input_q->head = temp_queue.head;
  }
}


/*
 * Given a character and a string, perform alias replacement on it.
 *
 * Return values:
 *   0: String was modified in place; call command_interpreter immediately.
 *   1: String was _not_ modified in place; rather, the expanded aliases
 *      have been placed at the front of the character's input queue.
 */
int perform_alias(struct descriptor_data *d, char *orig)
{
  char first_arg[MAX_INPUT_LENGTH], *ptr;
  struct alias *a, *tmp;

  /* bail out immediately if the guy doesn't have any aliases */
/* if ((tmp = GET_ALIASES(d->character)) == NULL)  Taken out now! zmud is better */
  return 0;

  /* find the alias we're supposed to match */
  ptr = any_one_arg(orig, first_arg);

  /* bail out if it's null */
  if (!*first_arg)
    return 0;

  /* if the first arg is not an alias, return without doing anything */
  if ((a = find_alias(tmp, first_arg)) == NULL)
    return 0;

  if (a->type == ALIAS_SIMPLE) {
    strcpy(orig, a->replacement);
    return 0;
  } else {
    perform_complex_alias(&d->input, ptr, a);
    return 1;
  }
}



/***************************************************************************
 * Various other parsing utilities                                         *
 **************************************************************************/

/*
 * searches an array of strings for a target string.  "exact" can be
 * 0 or non-0, depending on whether or not the match must be exact for
 * it to be returned.  Returns -1 if not found; 0..n otherwise.  Array
 * must be terminated with a '\n' so it knows to stop searching.
 */
int search_block(char *arg, char **list, int exact)
{
  register int i, l;

  /* Make into lower case, and get length of string */
  for (l = 0; *(arg + l); l++)
    if (!exact)			/* added 12/10/98 */
      *(arg + l) = LOWER(*(arg + l));

  if (exact) {
    for (i = 0; **(list + i) != '\n'; i++)
      if (!strcmp(arg, *(list + i)))
	return (i);
  } else {
    if (!l)
      l = 1;			/* Avoid "" to match the first available
				 * string */
    for (i = 0; **(list + i) != '\n'; i++)
      if (!strncasecmp(arg, *(list + i), l))
	return (i);
  }

  return -1;
}


int is_number(char *str)
{
  if (!str || !*str)		/* Test for NULL pointer or string. */
    return FALSE;
  if (*str == '-')		/* -'s in front are valid. */
    str++;
  while (*str)
    if (!isdigit(*(str++)))
      return FALSE;

  return TRUE;
}

/*
 * Function to skip over the leading spaces of a string.
 */
void skip_spaces(char **string)
{
  for (; **string && isspace(**string); (*string)++);
}


/*
 * Given a string, change all instances of double dollar signs ($$) to
 * single dollar signs ($).  When strings come in, all $'s are changed
 * to $$'s to avoid having users be able to crash the system if the
 * inputted string is eventually sent to act().  If you are using user
 * input to produce screen output AND YOU ARE SURE IT WILL NOT BE SENT
 * THROUGH THE act() FUNCTION (i.e., do_gecho, do_title, but NOT do_say),
 * you can call delete_doubledollar() to make the output look correct.
 *
 * Modifies the string in-place.
 */
char *delete_doubledollar(char *string)
{
  char *read, *write;

  /* If the string has no dollar signs, return immediately */
  if ((write = strchr(string, '$')) == NULL)
    return string;

  /* Start from the location of the first dollar sign */
  read = write;


  while (*read)			/* Until we reach the end of the string... */
    if ((*(write++) = *(read++)) == '$')	/* copy one char */
      if (*read == '$')
	read++;			/* skip if we saw 2 $'s in a row */

  *write = '\0';

  return string;
}


int fill_word(char *argument)
{
  return (search_block(argument, fill, TRUE) >= 0);
}


int reserved_word(char *argument)
{
  return (search_block(argument, reserved, TRUE) >= 0);
}


/*
 * copy the first non-fill-word, space-delimited argument of 'argument'
 * to 'first_arg'; return a pointer to the remainder of the string.
 */
char *one_argument(char *argument, char *first_arg)
{
  char *begin = first_arg;

  if (!argument) {
    log("SYSERR: one_argument received a NULL pointer.");
    *first_arg = '\0';
    return NULL;
  }
  do {
    skip_spaces(&argument);

    first_arg = begin;
    while (*argument && !isspace(*argument)) {
      *(first_arg++) = LOWER(*argument);
      argument++;
    }

    *first_arg = '\0';
  } while (fill_word(begin));
#ifdef MUDFTP
  skip_spaces(&argument);
#endif
  return argument;
}


/*
 * one_word is like one_argument, except that words in quotes ("") are
 * considered one word.
 */
char *one_word(char *argument, char *first_arg)
{
  char *begin = first_arg;

  do {
    skip_spaces(&argument);

    first_arg = begin;

    if (*argument == '\"') {
      argument++;
      while (*argument && *argument != '\"') {
	*(first_arg++) = LOWER(*argument);
	argument++;
      }
      argument++;
    } else {
      while (*argument && !isspace(*argument)) {
	*(first_arg++) = LOWER(*argument);
	argument++;
      }
    }

    *first_arg = '\0';
  } while (fill_word(begin));

  return argument;
}


/* same as one_argument except that it doesn't ignore fill words */
char *any_one_arg(char *argument, char *first_arg)
{
  skip_spaces(&argument);

  while (*argument && !isspace(*argument)) {
    *(first_arg++) = LOWER(*argument);
    argument++;
  }

  *first_arg = '\0';

  return argument;
}


/*
 * Same as one_argument except that it takes two args and returns the rest;
 * ignores fill words
 */
char *two_arguments(char *argument, char *first_arg, char *second_arg)
{
  return one_argument(one_argument(argument, first_arg), second_arg);	/* :-) */
}

char *three_arguments(char *argument, char *first_arg, char *second_arg, char *third_arg)
{
  return one_argument(one_argument(one_argument(argument, first_arg), second_arg), third_arg);
}

/*
 * Same as any_one_arg except that it takes two args and returns the rest;
 * ignores fill words
 */
char *any_two_arg(char *argument, char *first_arg, char *second_arg)
{
  return any_one_arg(any_one_arg(argument, first_arg), second_arg);	/* :-) */
}

/*
 * determine if a given string is an abbreviation of another
 * (now works symmetrically -- JE 7/25/94)
 *
 * that was dumb.  it shouldn't be symmetrical.  JE 5/1/95
 * 
 * returnss 1 if arg1 is an abbreviation of arg2
 */
int is_abbrev(char *arg1, char *arg2)
{
  if (!*arg1)
    return 0;

  for (; *arg1 && *arg2; arg1++, arg2++)
    if (LOWER(*arg1) != LOWER(*arg2))
      return 0;

  if (!*arg1)
    return 1;
  else
    return 0;
}

/* return first space-delimited token in arg1; remainder of string in arg2 */
void half_chop(char *string, char *arg1, char *arg2)
{
  char *temp;

  temp = any_one_arg(string, arg1);
  skip_spaces(&temp);
  strcpy(arg2, temp);
}



/* Used in specprocs, mostly.  (Exactly) matches "command" to cmd number */
int find_command(char *command)
{
  int cmd;

  for (cmd = 0; *complete_cmd_info[cmd].command != '\n'; cmd++)
/*    if (!strcmp(complete_cmd_info[cmd].command, command)) */
    if (is_abbrev(command, complete_cmd_info[cmd].command))
      return cmd;

  vlogf("find_command failed for %s", command);
  return -1;
}


int special(struct char_data *ch, int cmd, char *command, char *arg, int why_called)
{
  register struct obj_data *i;
  register struct char_data *k;
  int j;
  int zone_closed = zone_table[world[ch->in_room].zone].closed;

#if 0
  /* special in zone? */
  if (GET_ZONE_SPEC(ch->in_room) != NULL)
    if (GET_ZONE_SPEC(world[ch->in_room].zone) (ch, world + ch->in_room, cmd, command, arg, why_called))
      return 1;
#endif
  /* special in room? */
  if (!zone_closed && (GET_ROOM_SPEC(ch->in_room) != NULL))
    if (GET_ROOM_SPEC(ch->in_room) (ch, world + ch->in_room, cmd, command, arg, why_called))
      return 1;

  /* special in equipment list? */
  for (j = 0; j < NUM_WEARS; j++)
    if (GET_EQ(ch, j) && GET_OBJ_SPEC(GET_EQ(ch, j)) != NULL)
      if (GET_OBJ_SPEC(GET_EQ(ch, j)) (ch, GET_EQ(ch, j), cmd, command, arg, why_called))
	return 1;

  /* special in inventory? */
  for (i = ch->carrying; i; i = i->next_content)
    if (GET_OBJ_SPEC(i) != NULL)
      if (GET_OBJ_SPEC(i) (ch, i, cmd, command, arg, why_called))
	return 1;

  /* special in mobile present? */
  if (!zone_closed)
    for (k = world[ch->in_room].people; k; k = k->next_in_room)
      if (GET_MOB_SPEC(k) != NULL)
	if (GET_MOB_SPEC(k) (ch, k, cmd, command, arg, why_called))
	  return 1;

  /* special in object present? */
  if (!zone_closed)
    for (i = world[ch->in_room].contents; i; i = i->next_content)
      if (GET_OBJ_SPEC(i) != NULL)
	if (GET_OBJ_SPEC(i) (ch, i, cmd, command, arg, why_called))
	  return 1;

  return 0;
}



/* *************************************************************************
   *  Stuff for controlling the non-playing sockets (get name, pwd etc)       *
   ************************************************************************* */


/* locate entry in p_table with entry->name == name. -1 mrks failed search */
int find_name(char *name)
{
  int i;

  for (i = 0; i <= top_of_p_table; i++) {
    if (!str_cmp((player_table + i)->name, name))
      return i;
  }

  return -1;
}


int _parse_name(char *arg, char *name)
{
  int i;

  /* skip whitespaces */
  for (; isspace(*arg); arg++);

  for (i = 0; (*name = *arg); arg++, i++, name++)
    if (!isalpha(*arg))
      return 1;

  if (!i)
    return 1;

  return 0;
}


#define RECON		1
#define USURP		2
#define UNSWITCH	3

int perform_dupe_check(struct descriptor_data *d)
{
  struct descriptor_data *k, *next_k;
  struct char_data *target = NULL, *ch, *next_ch;
  int mode = 0;

  int id = GET_IDNUM(d->character);

  /*
   * Now that this descriptor has successfully logged in, disconnect all
   * other descriptors controlling a character with the same ID number.
   */

  for (k = descriptor_list; k; k = next_k) {
    next_k = k->next;

    if (k == d)
      continue;

    if (k->original && (GET_IDNUM(k->original) == id)) {	/* switched char */
      SEND_TO_Q("\r\nMultiple login detected -- disconnecting.\r\n", k);
      STATE(k) = CON_CLOSE;
      if (!target) {
	target = k->original;
	mode = UNSWITCH;
      }
      if (k->character)
	k->character->desc = NULL;
      k->character = NULL;
      k->original = NULL;
    } else if (k->character && (GET_IDNUM(k->character) == id)) {
      if (!target && STATE(k) == CON_PLAYING) {
	SEND_TO_Q("\r\nThis body has been usurped!\r\n", k);
	target = k->character;
	mode = USURP;
      }
      k->character->desc = NULL;
      k->character = NULL;
      k->original = NULL;
      SEND_TO_Q("\r\nMultiple login detected -- disconnecting.\r\n", k);
      STATE(k) = CON_CLOSE;
    }
  }

  /*
   * now, go through the character list, deleting all characters that
   * are not already marked for deletion from the above step (i.e., in the
   * CON_HANGUP state), and have not already been selected as a target for
   * switching into.  In addition, if we haven't already found a target,
   * choose one if one is available (while still deleting the other
   * duplicates, though theoretically none should be able to exist).
   */

  for (ch = character_list; ch; ch = next_ch) {
    next_ch = ch->next;

    if (IS_NPC(ch))
      continue;
    if (GET_IDNUM(ch) != id)
      continue;

    /* ignore chars with descriptors (already handled by above step) */
    if (ch->desc)
      continue;

    /* don't extract the target char we've found one already */
    if (ch == target)
      continue;

    /* we don't already have a target and found a candidate for switching */
    if (!target) {
      target = ch;
      mode = RECON;
      continue;
    }
    /* we've found a duplicate - blow him away, dumping his eq in limbo. */
    if (ch->in_room != NOWHERE)
      char_from_room(ch);
    char_to_room(ch, 1, -1);
    extract_char(ch);
  }

  /* no target for swicthing into was found - allow login to continue */
  if (!target)
    return 0;

  /* Okay, we've found a target.  Connect d to target. */
  free_char(d->character);	/* get rid of the old char */
  d->character = target;
  d->character->desc = d;
  d->original = NULL;
  d->character->char_specials.timer = 0;
  REMOVE_BIT(PLR_FLAGS(d->character), PLR_MAILING | PLR_WRITING);
  STATE(d) = CON_PLAYING;

  switch (mode) {
  case RECON:
    SEND_TO_Q("Reconnecting.\r\n", d);
    act("$n has reconnected.", TRUE, d->character, 0, 0, PROXIMITY);
    sprintf(buf, "%s [%s] has reconnected.", GET_NAME(d->character), d->host);
    break;
  case USURP:
    SEND_TO_Q("You take over your own body, already in use!\r\n", d);
    act("$n suddenly keels over in pain, surrounded by a white aura...\r\n"
	"$n's body has been taken over by a new spirit!",
	TRUE, d->character, 0, 0, PROXIMITY);
    sprintf(buf, "%s has re-logged in ... disconnecting old socket.",
	    GET_NAME(d->character));
    mudlog(buf, NRM, MAX(LVL_IMMORT, GET_INVIS_LEV(d->character)), TRUE);
    break;
  case UNSWITCH:
    SEND_TO_Q("Reconnecting to unswitched char.", d);
    sprintf(buf, "%s [%s] has reconnected.", GET_NAME(d->character), d->host);
    mudlog(buf, NRM, MAX(LVL_IMMORT, GET_INVIS_LEV(d->character)), TRUE);
    break;
  }

  return 1;
}


/* load the player, put them in the right room - used by copyover_recover too */
int enter_player_game(struct descriptor_data *d)
{
  extern sh_int r_mortal_start_room;
  extern sh_int r_immort_start_room;
  extern sh_int r_frozen_start_room;

  sh_int load_room, xcord, ycord, zcord;
  int load_result;

  reset_char(d->character);
  if (PLR_FLAGGED(d->character, PLR_INVSTART))
    GET_INVIS_LEV(d->character) = GET_LEVEL(d->character);


#if 0
  /* make sure they have an appearance */
  if (!d->character->player.short_descr)
    generate_desc(d->character);
#endif
#if 0
  /* alphabetize the descriptor list */
  sort_desc_in_list(d);
#endif

  /* put character to their loadroom before autoequipping them */
  load_room = real_room(GET_LOADROOM(d->character));

  /* If char was saved with NOWHERE, or real_room above failed... */
  if (load_room == NOWHERE) {
    if (GET_LEVEL(d->character))
      vlogf("%s attempted to load NOWHERE! %d (%dv %dr)", GET_NAME(d->character), GET_LOADROOM(d->character), load_room, real_room(GET_LOADROOM(d->character)));
    if (GET_LEVEL(d->character) >= LVL_IMMORT)
      load_room = r_immort_start_room;
    else
      load_room = r_mortal_start_room;
  }
  if (PLR_FLAGGED(d->character, PLR_FROZEN))
    load_room = r_frozen_start_room;
  /* error check */
  if (!GET_LEVEL(d->character)) {
    load_room = r_mortal_start_room;
    xcord = 2;
    ycord = 2;
    zcord = 0;
  } else {
    /* save the pfile saved locations */
    xcord = GET_X_CORD(d->character);
    ycord = GET_Y_CORD(d->character);
    zcord = GET_Z_CORD(d->character);
  }
  /* temp placement, just so we can load items properly */
  char_to_room(d->character, load_room, -1);

  if ((load_result = Crash_load(d->character)))
    vlogf("LOADCHAR: %s appears to have lost items during rent! load_result = %d", GET_NAME(d->character), load_result);

  /* Now, final place them at last saved coordinates */
  char_from_room(d->character);
  put_char_to_room(d->character, load_room, -1, xcord, ycord, zcord);

  GET_ID(d->character) = GET_IDNUM(d->character);

  /* set some battle defaults */
  GET_AIMING(d->character) = LOCATION_TORSO;
  GET_FORM(d->character) = FORM_SWING;
  GET_HIT_WA(d->character) = GET_HIT(d->character) / 2;
  GET_HIT_WH(d->character) = GET_HIT(d->character) / 4;
  GET_HIT_SA(d->character) = GET_HIT(d->character) / 2;
  GET_HIT_SH(d->character) = GET_HIT(d->character) / 4;
  GET_HIT_TO(d->character) = GET_HIT(d->character);
  GET_HIT_LL(d->character) = GET_HIT(d->character) / 2;
  GET_HIT_LF(d->character) = GET_HIT(d->character) / 4;
  GET_HIT_RL(d->character) = GET_HIT(d->character) / 2;
  GET_HIT_RF(d->character) = GET_HIT(d->character) / 4;
  GET_HIT_HD(d->character) = GET_HIT(d->character) / 4;


  GET_Z_CORD(d->character) = 0;
  CHAR_POLYMORPH_OBJ(d->character) = NULL;
  MORPH_MOB(d->character) = NULL;
  /* make sure these are non existant */
  REMOVE_BIT(AFF3_FLAGS(d->character), AFF3_POLYMORPH);
  d->olc = NULL;

  save_char(d->character, d->character->in_room);
  send_to_char(WELC_MESSG, d->character);

  send_to_char("!!SOUND(start* T=generic)", d->character);

  send_to_char("\r\n", d->character);
  if (IS_GREY_TERM(d)) {
    send_to_char(PLUGIN_VERSION_START, d->character);
    send_to_char(PLUGIN_VERSION, d->character);
    send_to_char(PLUGIN_VERSION_END, d->character);
    send_to_char("\r\n", d->character);
  }
  d->character->next = character_list;
  character_list = d->character;

  SET_POS(d->character, POS_STANDING + STAT_NORMAL);
  return load_result;
}


/* deal with newcomers and other non-playing sockets */


/* deal with newcomers and other non-playing sockets */
void nanny(struct descriptor_data *d, char *arg)
{
  char buf[128];
  int player_i, load_result;
  char tmp_name[MAX_INPUT_LENGTH];
  struct char_file_u tmp_store;
  extern int max_bad_pws;

  int load_char(char *name, struct char_file_u *char_element);
  int parse_class(struct char_data *ch, char arg);
  int parse_race(char arg);
#ifdef MUDFTP
  if (d->connected != CON_FTP_DATA)
#endif
    skip_spaces(&arg);

  switch (STATE(d)) {

    /*. OLC states . */
  case CON_OEDIT:
    oedit_parse(d, arg);
    break;
  case CON_REDIT:
    redit_parse(d, arg);
    break;
  case CON_ZEDIT:
    zedit_parse(d, arg);
    break;
  case CON_MEDIT:
    medit_parse(d, arg);
    break;
  case CON_SEDIT:
    sedit_parse(d, arg);
    break;
  case CON_TEDIT:
    trigedit_parse(d, arg);
    break;
  case CON_AEDIT:
    aedit_parse(d, arg);
    break;
  case CON_QEDIT:
    qedit_parse(d, arg);
    break;
  case CON_GEDIT:		/* Editing guilds */
    parse_guild_edit(d, arg);
    break;
  case CON_HEDIT:
    hedit_parse(d, arg);
    break;
  case CON_TERM:
    select_terminal(d, arg);
    break;
  case CON_GET_NAME:		/* wait for input of name */
    if (d->character == NULL) {
      CREATE(d->character, struct char_data, 1);
      clear_char(d->character);
      CREATE(d->character->player_specials, struct player_special_data, 1);
      d->character->desc = d;
    }
    if (!*arg)
      d->close_me = TRUE;
    else {
      if ((_parse_name(arg, tmp_name)) || strlen(tmp_name) < 2 ||
	  strlen(tmp_name) > MAX_NAME_LENGTH ||
	  fill_word(strcpy(buf, tmp_name)) || reserved_word(buf)) {
	if (!isname("new", buf)) {
	  SEND_TO_Q("Invalid name, please try another.\r\n"
		    "Name: ", d);
	  return;
	} else
	  sprintf(tmp_name, "%s", random_name());
      }
      if ((player_i = load_char(tmp_name, &tmp_store)) > -1) {
	store_to_char(&tmp_store, d->character);
	GET_PFILEPOS(d->character) = player_i;

	if (PLR_FLAGGED(d->character, PLR_DELETED)) {
	  free_char(d->character);
	  CREATE(d->character, struct char_data, 1);
	  clear_char(d->character);
	  CREATE(d->character->player_specials, struct player_special_data, 1);
	  d->character->desc = d;
	  CREATE(d->character->player.name, char, strlen(tmp_name) + 1);
	  strcpy(d->character->player.name, CAP(tmp_name));
	  GET_PFILEPOS(d->character) = player_i;
	  sprintf(buf, "Did I get that right, %s (Y/N)? ", tmp_name);
	  SEND_TO_Q(buf, d);
	  STATE(d) = CON_NAME_CNFRM;
	} else {
	  /* undo it just in case they are set */
	  REMOVE_BIT(PLR_FLAGS(d->character),
		     PLR_WRITING | PLR_MAILING | PLR_CRYO);

	  SEND_TO_Q("Password: ", d);
	  echo_off(d);
	  d->idle_tics = 0;
	  STATE(d) = CON_PASSWORD;
	}
      } else {
	/* player unknown -- make new character */

	if (!Valid_Name(tmp_name)) {
	  SEND_TO_Q("Invalid name, please try another.\r\n", d);
	  SEND_TO_Q("Name: ", d);
	  return;
	}
	CREATE(d->character->player.name, char, strlen(tmp_name) + 1);
	strcpy(d->character->player.name, CAP(tmp_name));

	sprintf(buf, "Your name is %s, correct? (Y/N) ", tmp_name);
	SEND_TO_Q(buf, d);
	STATE(d) = CON_NAME_CNFRM;
      }
    }
    break;
  case CON_NAME_CNFRM:		/* wait for conf. of new name    */
    if (UPPER(*arg) == 'Y') {
      if (isbanned(d->host) >= BAN_NEW) {
	sprintf(buf, "Request for new char %s denied from [%s] (siteban)",
		GET_NAME(d->character), d->host);
	mudlog(buf, NRM, LVL_GOD1, TRUE);
	SEND_TO_Q("Sorry, new characters are not allowed from your site!\r\n", d);
	STATE(d) = CON_CLOSE;
	return;
      }
      if (restricted) {
	SEND_TO_Q("Sorry, new players can't be created at the moment.\r\n", d);
	sprintf(buf, "Request for new char %s denied from [%s] (wizlock)",
		GET_NAME(d->character), d->host);
	mudlog(buf, NRM, LVL_GOD1, TRUE);
	STATE(d) = CON_CLOSE;
	return;
      }
      SEND_TO_Q("New character.\r\n", d);
      sprintf(buf, "Give me a password for %s: ", GET_NAME(d->character));
      SEND_TO_Q(buf, d);
      echo_off(d);
      STATE(d) = CON_NEWPASSWD;
    } else if (*arg == 'n' || *arg == 'N') {
      SEND_TO_Q("Sorry, my fault. Please enter it again ('new' for random) : ", d);
      FREE(d->character->player.name);
      d->character->player.name = NULL;
      STATE(d) = CON_GET_NAME;
    } else {
      SEND_TO_Q("Please type Yes or No: ", d);
    }
    break;
  case CON_PASSWORD:		/* get pwd for known player      */
    /*
     * To really prevent duping correctly, the player's record should
     * be reloaded from disk at this point (after the password has been
     * typed).  However I'm afraid that trying to load a character over
     * an already loaded character is going to cause some problem down the
     * road that I can't see at the moment.  So to compensate, I'm going to
     * (1) add a 15 or 20-second time limit for entering a password, and (2)
     * re-add the code to cut off duplicates when a player quits.  JE 6 Feb 96
     */
    echo_on(d);		/* turn echo back on */

    if (!*arg)
      d->close_me = TRUE;
    else {
      if (strncmp(CRYPT(arg, GET_PASSWD(d->character)), GET_PASSWD(d->character), MAX_PWD_LENGTH)) {
	sprintf(buf, "Bad PW: %s [%s]", GET_NAME(d->character), d->host);
	mudlog(buf, BRF, LVL_GOD1, TRUE);
	GET_BAD_PWS(d->character)++;
	save_char(d->character, NOWHERE);
	if (++(d->bad_pws) >= max_bad_pws) {	/* 3 strikes and you're out. */
	  SEND_TO_Q("Wrong password... disconnecting.\r\n", d);
	  STATE(d) = CON_CLOSE;
	} else {
	  SEND_TO_Q("Wrong password.\r\nPassword: ", d);
	  echo_off(d);
	}
	return;
      }
      /* Password was correct. */
      load_result = GET_BAD_PWS(d->character);
      GET_BAD_PWS(d->character) = 0;
      d->bad_pws = 0;

      if (isbanned(d->host) == BAN_SELECT &&
	  !PLR_FLAGGED(d->character, PLR_SITEOK)) {
	SEND_TO_Q("Sorry, this char has not been cleared for login from your site!\r\n", d);
	STATE(d) = CON_CLOSE;
	sprintf(buf, "Connection attempt for %s denied from %s",
		GET_NAME(d->character), d->host);
	mudlog(buf, NRM, LVL_GOD1, TRUE);
	return;
      }
      if (GET_LEVEL(d->character) < restricted) {
	SEND_TO_Q("The game is temporarily restricted.. try again later.\r\n", d);
	STATE(d) = CON_CLOSE;
	sprintf(buf, "Request for login denied for %s [%s] (wizlock)",
		GET_NAME(d->character), d->host);
	mudlog(buf, NRM, LVL_GOD1, TRUE);
	return;
      }
      /* check and make sure no other copies of this player are logged in */
      if (perform_dupe_check(d))
	return;

      if (GET_LEVEL(d->character) >= LVL_IMMORT)
	SEND_TO_Q(imotd, d);
      else
	SEND_TO_Q(motd, d);

      sprintf(buf, "%s [%s] has connected.", GET_NAME(d->character), d->host);
      mudlog(buf, BRF, MAX(LVL_IMMORT, GET_INVIS_LEV(d->character)), TRUE);

      if (load_result) {
	sprintf(buf, "\r\n\r\n\007\007\007"
	     "&=LR%d LOGIN FAILURE%s SINCE LAST SUCCESSFUL LOGIN.&n\r\n",
		load_result, (load_result > 1) ? "S" : "");
	SEND_TO_Q(buf, d);
	GET_BAD_PWS(d->character) = 0;
      }
      SEND_TO_Q("\r\n*** PRESS RETURN: ", d);
      STATE(d) = CON_RMOTD;
    }
    break;

  case CON_NEWPASSWD:
  case CON_CHPWD_GETNEW:
    if (!*arg || strlen(arg) > MAX_PWD_LENGTH || strlen(arg) < 3 ||
	!str_cmp(arg, GET_NAME(d->character))) {
      SEND_TO_Q("\r\nIllegal password.\r\n", d);
      SEND_TO_Q("Password: ", d);
      return;
    }
    strncpy(GET_PASSWD(d->character), CRYPT(arg, GET_NAME(d->character)), MAX_PWD_LENGTH);
    *(GET_PASSWD(d->character) + MAX_PWD_LENGTH) = '\0';

    SEND_TO_Q("\r\nPlease retype password: ", d);
    if (STATE(d) == CON_NEWPASSWD)
      STATE(d) = CON_CNFPASSWD;
    else
      STATE(d) = CON_CHPWD_VRFY;

    break;

  case CON_CNFPASSWD:
  case CON_CHPWD_VRFY:
    if (strncmp(CRYPT(arg, GET_PASSWD(d->character)), GET_PASSWD(d->character),
		MAX_PWD_LENGTH)) {
      SEND_TO_Q("\r\nPasswords don't match... start over.\r\n", d);
      SEND_TO_Q("Password: ", d);
      if (STATE(d) == CON_CNFPASSWD)
	STATE(d) = CON_NEWPASSWD;
      else
	STATE(d) = CON_CHPWD_GETNEW;
      return;
    }
    echo_on(d);

    if (STATE(d) == CON_CNFPASSWD) {
      SEND_TO_Q("What is your sex (M/F)? ", d);
      CREATE(d->olc, struct olc_data, 1);
      STATE(d) = CON_PEDIT;
      OLC_MODE(d) = PEDIT_QSEX;
    } else {
      save_char(d->character, NOWHERE);
      echo_on(d);
      SEND_TO_Q("\r\nDone.\n\r", d);
      SEND_TO_Q(MENU, d);
      STATE(d) = CON_MENU;
    }
    break;

  case CON_PEDIT:		/* query sex of new user         */
    pedit_parse(d, arg);
    break;

  case CON_RMOTD:		/* read CR after printing motd   */
    SEND_TO_Q(MENU, d);
    STATE(d) = CON_MENU;
    break;

  case CON_MENU:		/* get selection from main menu  */
    switch (*arg) {
    case '0':
      SEND_TO_Q("Axes high my friend, we shall battle again on the morrow.\r\n", d);
      STATE(d) = CON_CLOSE;
      break;

    case '1':
      load_result = enter_player_game(d);

      act("$n has entered the game.", TRUE, d->character, 0, 0, PROXIMITY);
      greet_mtrigger(d->character, -1);
      greet_memory_mtrigger(d->character);

      STATE(d) = CON_PLAYING;
      if (!GET_LEVEL(d->character)) {
	do_start(d->character);
	send_to_char(START_MESSG, d->character);
      }
      look_at_room(d->character, 0);
      if (has_mail(GET_IDNUM(d->character)))
	send_to_char("You have mail waiting.\r\n", d->character);
      if (load_result == 2) {	/* rented items lost */
	send_to_char("\r\n\007You could not afford your rent!\r\n"
	  "Your possesions have been donated to the Salvation Army!\r\n",
		     d->character);
      }
      d->has_prompt = 0;
      break;

    case '2':
      if (d->character->player.description) {
	SEND_TO_Q("Current description:\r\n", d);
	SEND_TO_Q(d->character->player.description, d);
	/*
	 * Don't free this now... so that the old description gets loaded
	 * as the current buffer in the editor.  Do setup the ABORT buffer
	 * here, however.
	 *
	 * FREE(d->character->player.description);
	 * d->character->player.description = NULL;
	 */
	d->backstr = str_dup(d->character->player.description);
      }
      SEND_TO_Q("Enter the new text you'd like others to see when they look at you.\r\n", d);
      SEND_TO_Q("(/s saves /h for help)\r\n", d);
#ifdef MUDFTP
      string_write(d, &d->character->player.description, EXDSCR_LENGTH, 0, NULL);
#else
      d->str = &d->character->player.description;
      d->max_str = EXDSCR_LENGTH;
#endif
      STATE(d) = CON_EXDESC;
      break;

    case '3':
      SEND_TO_Q("\r\nEnter your old password: ", d);
      echo_off(d);
      STATE(d) = CON_CHPWD_GETOLD;
      break;

    case '4':
      SEND_TO_Q("\r\nEnter your password for verification: ", d);
	echo_off(d);
      STATE(d) = CON_DELCNF1;
      break;

    case '5':
      page_string(d, background, 0);
      STATE(d) = CON_RMOTD;
      break;

    default:
      SEND_TO_Q("\r\nThat's not a menu choice!\r\n", d);
      SEND_TO_Q(MENU, d);
      break;
    }

    break;

  case CON_CHPWD_GETOLD:
    if (strncmp(CRYPT(arg, GET_PASSWD(d->character)), GET_PASSWD(d->character), MAX_PWD_LENGTH)) {
	echo_on(d);
      SEND_TO_Q("\r\nIncorrect password.\r\n", d);
      SEND_TO_Q(MENU, d);
      STATE(d) = CON_MENU;
      return;
    } else {
      SEND_TO_Q("\r\nEnter a new password: ", d);
      STATE(d) = CON_CHPWD_GETNEW;
      return;
    }
    break;

  case CON_DELCNF1:
      echo_on(d);
    if (strncmp(CRYPT(arg, GET_PASSWD(d->character)), GET_PASSWD(d->character), MAX_PWD_LENGTH)) {
      SEND_TO_Q("\r\nIncorrect password.\r\n", d);
      SEND_TO_Q(MENU, d);
      STATE(d) = CON_MENU;
    } else {
      SEND_TO_Q("\r\nYOU ARE ABOUT TO DELETE THIS CHARACTER PERMANENTLY.\r\n"
		"ARE YOU ABSOLUTELY SURE?\r\n\r\n"
		"Please type \"yes\" to confirm: ", d);
      STATE(d) = CON_DELCNF2;
    }
    break;

  case CON_DELCNF2:
    if (!strcmp(arg, "yes") || !strcmp(arg, "YES")) {
      if (PLR_FLAGGED(d->character, PLR_FROZEN)) {
	SEND_TO_Q("You try to kill yourself, but the ice stops you.\r\n", d);
	SEND_TO_Q("Character not deleted.\r\n\r\n", d);
	STATE(d) = CON_CLOSE;
	return;
      }
      if (GET_LEVEL(d->character) < LVL_GRGOD)
	SET_BIT(PLR_FLAGS(d->character), PLR_DELETED);
      save_char(d->character, NOWHERE);
      Crash_delete_file(GET_NAME(d->character));
      sprintf(buf, "Character '%s' deleted!\r\n"
	      "Thy self shall surely join the gods in infamy my friend.\r\n", GET_NAME(d->character));
      SEND_TO_Q(buf, d);
      sprintf(buf, "%s (lev %d) has self-deleted.", GET_NAME(d->character),
	      GET_LEVEL(d->character));
      mudlog(buf, NRM, LVL_GOD1, TRUE);
      STATE(d) = CON_CLOSE;
      return;
    } else {
      SEND_TO_Q("\r\nCharacter not deleted.\r\n", d);
      SEND_TO_Q(MENU, d);
      STATE(d) = CON_MENU;
    }
    break;

#ifdef MUDFTP
  case CON_FTP_AUTH:
    handle_ftp_auth(d, arg);
    break;

  case CON_FTP_COMMAND:
    handle_ftp_command(d, arg);
    break;

  case CON_FTP_DATA:
    handle_ftp_data(d, arg);
    break;
#endif
  case CON_CLOSE:
    d->close_me = TRUE;
    break;

  default:
    log("SYSERR: Nanny: illegal state of con'ness; closing connection");
    close_socket(d);
    break;
  }
}


void deleteChar(struct char_data *ch)
{

  SET_BIT(PLR_FLAGS(ch), PLR_DELETED);
  save_char(ch, NOWHERE);
  Crash_delete_file(GET_NAME(ch));
  sprintf(buf, "%s (lev %d) was deleted.", GET_NAME(ch),
	  GET_LEVEL(ch));
  mudlog(buf, NRM, LVL_GOD1, TRUE);

};
