/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"
#include "structs.h"
#include "comm.h"
#include "utils.h"


char *att_kick_kill_ch[] =
{
  "Your kick caves $N's chest in, killing $M.",
  "Your kick destroys $N's arm and caves in one side of $S rib cage.",
  "Your kick smashes through $N's leg and into $S pelvis, killing $M.",
  "Your kick shatters $N's skull.",
  "Your kick at $N's snout shatters $S jaw, killing $M.",
  "You kick $N in the rump with such force that $E keels over dead.",
  "You kick $N in the belly, mangling several ribs and killing $M instantly.",
  "$N's scales cave in as your mighty kick kills $N.",
"Your kick rips bark asunder and leaves fly everywhere, killing the $N.",
  "Bits of $N are sent flying as you kick him to pieces.",
  "You punt $N across the room, $E lands in a heap of broken flesh.",
  "You kick $N in the groin; $E dies screaming an octave higher.",
  ".",				/* GHOST */
  "Feathers fly about as you blast $N to pieces with your kick.",
  "Your kick splits $N to pieces, rotting flesh flies everywhere.",
  "Your kick topples $N over, killing it.",
  "Your foot shatters cartilage, sending bits of $N everywhere.",
  "You launch a mighty kick at $N's gills, killing it.",
  "Your kick at $N sends $M to the grave.",
  "."
};
char *att_kick_kill_victim[] =
{
  "$n crushes you beneath $s foot, killing you.",
  "$n destroys your arm and half your ribs.  You die.",
  "$n neatly splits your groin in two, you collapse and die instantly.",
  "$n splits your head in two, killing you instantly.",
  "$n forces your jaw into the lower part of your brain.",
  "$n kicks you from behind, snapping your spine and killing you.",
  "$n kicks your stomach and you into the great land beyond!!",
  "Your scales are no defense against $n's mighty kick.",
"$n rips you apart with a massive kick, you die in a flutter of leaves.",
  "You are torn to little pieces as $n splits you with $s kick.",
  "$n's kick sends you flying, you die before you land.",
  "Puny little $n manages to land a killing blow to your groin, OUCH!",
  ".",				/* GHOST */
  "Your feathers fly about as $n pulverizes you with a massive kick.",
  "$n's kick rips your rotten body into shreds, and your various pieces die.",
  "$n kicks you so hard, you fall over and die.",
  "$n shatters your exoskeleton, you die.",
  "$n kicks you in the gills!  You cannot breath..... you die!.",
  "$n sends you to the grave with a mighty kick.",
  "."
};
char *att_kick_kill_room[] =
{
  "$n strikes $N in chest, shattering the ribs beneath it.",
  "$n kicks $N in the side, destroying $S arm and ribs.",
  "$n nails $N in the groin, the pain killing $M.",
  "$n shatters $N's head, reducing $M to a twitching heap!",
  "$n blasts $N in the snout, destroying bones and causing death.",
  "$n kills $N with a massive kick to the rear.",
  "$n sends $N to the grave with a massive blow to the stomach!",
  "$n ignores $N's scales and kills $M with a mighty kick.",
  "$n sends bark and leaves flying as $e splits $N in two.",
  "$n blasts $N to pieces with a ferocious kick.",
  "$n sends $N flying, $E lands with a LOUD THUD, making no other noise.",
  "$N falls to the ground and dies clutching $S crotch due to $n's kick.",
  ".",				/* GHOST */
  "$N disappears into a cloud of feathers as $n kicks $M to death.",
  "$n blasts $N's rotten body into pieces with a powerful kick.",
  "$n kicks $N so hard, it falls over and dies.",
  "$n blasts $N's exoskeleton to little fragments.",
  "$n kicks $N in the gills, killing it.",
  "$n sends $N to the grave with a mighty kick.",
  "."
};
char *att_kick_miss_ch[] =
{
  "$N steps back, and your kick misses $M.",
  "$N deftly blocks your kick with $S forearm.",
  "$N dodges, and you miss your kick at $S legs.",
  "$N ducks, and your foot flies a mile high.",
  "$N steps back and grins evilly as your foot flies by $S face.",
  "$N laughs at your feeble attempt to kick $M from behind.",
  "Your kick at $N's belly makes it laugh.",
  "$N chuckles as your kick bounces off $S tough scales.",
  "You kick $N in the side, denting your foot.",
  "Your sloppy kick is easily avoided by $N.",
  "You misjudge $N's height and kick well above $S head.",
  "You stub your toe against $N's shin as you try to kick $M.",
  "Your kick passes through $N!!",	/* Ghost */
  "$N nimbly flitters away from your kick.",
  "$N sidesteps your kick and sneers at you.",
  "Your kick bounces off $N's leathery hide.",
  "Your kick bounces off $N's tough exoskeleton.",
  "$N deflects your kick with a fin.",
  "$N avoids your paltry attempt at a kick.",
  "."
};
char *att_kick_miss_victim[] =
{
  "$n misses you with $s clumsy kick at your chest.",
  "You block $n's feeble kick with your arm.",
  "You dodge $n's feeble leg sweep.",
  "You duck under $n's lame kick.",
  "You step back and grin as $n misses your face with a kick.",
  "$n attempts a feeble kick from behind, which you neatly avoid.",
  "You laugh at $n's feeble attempt to kick you in the stomach.",
  "$n kicks you, but your scales are much too tough for that wimp.",
  "You laugh as $n dents $s foot on your bark.",
  "You easily avoid a sloppy kick from $n.",
  "$n's kick parts your hair but does little else.",
  "$n's light kick to your shin bearly gets your attention.",
  "$n passes through you with $s puny kick.",
  "You nimbly flitter away from $n's kick.",
  "You sneer as you sidestep $n's kick.",
  "$n's kick bounces off your tough hide.",
  "$n tries to kick you, but your too tough.",
  "$n tried to kick you, but you deflected it with a fin.",
  "You avoid $n's feeble attempt to kick you.",
  "."
};

char *att_kick_miss_room[] =
{
  "$n misses $N with a clumsy kick.",
  "$N blocks $n's kick with $S arm.",
  "$N easily dodges $n's feeble leg sweep.",
  "$N easily ducks under $n's lame kick.",
  "$N steps back and grins evilly at $n's feeble kick to $S face misses.",
  "$n launches a kick at $N's behind, but fails miserably.",
  "$N laughs at $n's attempt to kick $M in the stomach.",
  "$n tries to kick $N, but $s foot bounces off of $N's scales.",
  "$n hurts his foot trying to kick $N.",
  "$N avoids a lame kick launched by $n.",
  "$n misses a kick at $N due to $S small size.",
  "$n misses a kick at $N's groin, stubbing $s toe in the process.",
  "$n's foot goes right through $N!!!!",
  "$N flitters away from $n's kick.",
  "$N sneers at $n while sidestepping $s kick.",
  "$N's tough hide deflects $n's kick.",
  "$n hurts $s foot on $N's tough exterior.",
  "$n tries to kick $N, but is thwarted by a fin.",
  "$N avoids $n's feeble kick.",
  "."
};

char *att_kick_hit_ch[] =
{
  "Your kick crashes into $N's chest.",
  "Your kick hits $N in the side.",
  "You hit $N in the thigh with a hefty sweep.",
  "You hit $N in the face, sending $M reeling.",
  "You plant your foot firmly in $N's snout, smashing it to one side.",
  "You nail $N from behind, sending him reeling.",
  "You kick $N in the stomach, winding $M.",
  "You find a soft spot in $N's scales and launch a solid kick there.",
  "Your kick hits $N, sending small branches and leaves everywhere.",
  "Your kick contacts with $N, dislodging little pieces of $M.",
  "Your kick hits $N right in the stomach, rendering $M breathless.",
  "You stomp on $N's foot. After all, thats about all you can do to a giant.",
  ".",				/* GHOST */
  "Your kick  sends $N reeling through the air.",
  "You kick $N and feel rotten bones crunch from the blow.",
  "You smash $N with a hefty roundhouse kick.",
  "You kick $N, cracking it's exoskeleton.",
  "Your mighty kick rearranges $N's scales.",
  "You leap off the ground and crash into $N with a powerful kick.",
  "."
};

char *att_kick_hit_victim[] =
{
  "$n's kick crashes into your chest.",
  "$n's kick hits you in your side.",
  "$n's sweep catches you in the side and you almost stumble.",
  "$n hits you in the face, gee, what pretty colors...",
  "$n kicks you in the snout, smashing it up against your face.",
  "$n blasts you in the rear, ouch!",
  "Your breath rushes from you as $n kicks you in the stomach.",
  "$n finds a soft spot on your scales and kicks you, ouch!",
  "$n kicks you hard, sending leaves flying everywhere!",
  "$n kicks you in the side, dislodging small parts of you.",
  "You suddenly see $n's foot in your chest.",
  "$n lands a kick hard on your foot making you jump around in pain.",
  ".",				/* GHOST */
  "$n kicks you, and you go reeling through the air.",
  "$n kicks you and your bones crumble.",
  "$n hits you in the flank with a hefty roundhouse kick.",
  "$n ruins some of your scales with a well placed kick.",
  "$n leaps off of the grand and crashes into you with $s kick.",
  "."
};

char *att_kick_hit_room[] =
{
  "$n hits $N with a mighty kick to $S chest.",
  "$n whacks $N in the side with a sound kick.",
  "$n almost sweeps $N off of $S feet with a well placed leg sweep.",
  "$N's eyes roll as $n plants a foot in $S face.",
  "$N's snout is smashed as $n relocates it with $s foot.",
  "$n hits $N with an impressive kick from behind.",
  "$N gasps as $n kicks $M in the stomach.",
  "$n finds a soft spot in $N's scales and launches a solid kick there.",
  "$n kicks $N.  Leaves fly everywhere!!",
  "$n hits $N with a mighty kick, $N loses parts of $Mself.",
  "$n kicks $N in the stomach, rendering $M breathless.",
  "$n kicks $N in the foot, causing $N to hop around in pain.",
  ".",				/* GHOST */
  "$n sends $N reeling through the air with a mighty kick.",
  "$n kicks $N causing parts of $N to cave in!",
  "$n kicks $N in the side with a hefty roundhouse kick.",
  "$n kicks $N, cracking exo-skelelton.",
  "$n kicks $N hard, sending scales flying!",
  "$n leaps up and nails $N with a mighty kick.",
  "."
};

void kick_messages(struct char_data *ch, struct char_data *victim, int dam)
{
  int i;

  switch (GET_RACE(victim)) {
  case RACE_HUMAN:
  case RACE_DROW:
  case RACE_ELF:
  case RACE_HALFELF:
  case RACE_HALFORC:
  case RACE_GITHYANKI:
  case RACE_MINOTAUR:
  case RACE_OGRE:
  case RACE_TROLL:
  case RACE_GOLEM:
  case RACE_VAMPIRE:
  case RACE_CENTAUR:
    i = number(0, 3);
    break;
  case RACE_LYCANTHROPE:
  case RACE_HORSE:
    i = number(4, 6);
    break;
  case RACE_DRAGON:
  case RACE_SNAKE:
    i = number(4, 7);
    break;
/*
   case RACE_TREE:
   i = 8;
   break;
   case RACE_PARASITE:
   i = 9;
   break;
 */
  case RACE_HALFLING:
  case RACE_GNOME:
  case RACE_ORC:
  case RACE_GOBLIN:
    i = 10;
    break;
  case RACE_GIANT:
  case RACE_ELEMENTAL_FIRE:
  case RACE_ELEMENTAL_AIR:
  case RACE_ELEMENTAL_WATER:
  case RACE_ELEMENTAL_EARTH:
    if (!number(0, 1))
      i = 11;
    else
      i = 15;
    break;
  case RACE_GHOST:
    i = 12;
    break;
  case RACE_BIRD:
    i = 13;
    break;
/*
   case RACE_UNDEAD:
   i = 14;
   break;
 */
  case RACE_INSECT:
  case RACE_SPIDER:
    i = 16;
    break;
  case RACE_FISH:
    i = 17;
    break;
  default:
    i = 18;
  };
  if (!dam || IS_TRUSTED(victim)) {
    act(att_kick_miss_ch[i], FALSE, ch, ch->equipment[WEAR_WIELD], victim, TO_CHAR);
    act(att_kick_miss_victim[i], FALSE, ch, ch->equipment[WEAR_WIELD], victim,
	TO_VICT);
    act(att_kick_miss_room[i], FALSE, ch, ch->equipment[WEAR_WIELD], victim,
	TO_NOTVICT);
  } else if (GET_STAT(victim) == STAT_DEAD) {
    act(att_kick_kill_ch[i], FALSE, ch, ch->equipment[WEAR_WIELD], victim, TO_CHAR);
    act(att_kick_kill_victim[i], FALSE, ch, ch->equipment[WEAR_WIELD], victim,
	TO_VICT);
    act(att_kick_kill_room[i], FALSE, ch, ch->equipment[WEAR_WIELD], victim,
	TO_NOTVICT);
  } else {
    act(att_kick_hit_ch[i], FALSE, ch, ch->equipment[WEAR_WIELD], victim, TO_CHAR);
    act(att_kick_hit_victim[i], FALSE, ch, ch->equipment[WEAR_WIELD], victim,
	TO_VICT);
    act(att_kick_hit_room[i], FALSE, ch, ch->equipment[WEAR_WIELD], victim,
	TO_NOTVICT);
  }
}
