/* ************************************************************************
*  file:  autowiz.c                                     Part of CircleMUD *
*  Usage: self-updating wizlists                                          *
*  Written by Jeremy Elson                                                *
*  All Rights Reserved                                                    *
*  Copyright (C) 1993 The Trustees of The Johns Hopkins University        *
************************************************************************* */


/* 
   WARNING:  THIS CODE IS A HACK.  WE CAN NOT AND WILL NOT BE RESPONSIBLE
   FOR ANY NASUEA, DIZZINESS, VOMITING, OR SHORTNESS OF BREATH RESULTING
   FROM READING THIS CODE.  PREGNANT WOMEN AND INDIVIDUALS WITH BACK
   INJURIES, HEART CONDITIONS, OR ARE UNDER THE CARE OF A PHYSICIAN SHOULD
   NOT READ THIS CODE.

   -- The Management
 */

#include "conf.h"
#include "sysdep.h"

#include <signal.h>

#include "structs.h"
#include "utils.h"
#include "db.h"

#define IMM_LMARG "   "
#define IMM_NSIZE  16
#define LINE_LEN   3
#define MIN_LEVEL LVL_IMMORT

/* max level that should be in columns instead of centered */
#define COL_LEVEL LVL_IMMORT

struct name_rec {
  char name[MAX_NAME_LENGTH + 1];
  char title[MAX_TITLE_LENGTH + 1];
  struct name_rec *next;
};

struct control_rec {
  int level;
  char *level_name;
};

struct level_rec {
  struct control_rec *params;
  struct level_rec *next;
  struct name_rec *names;
};

struct control_rec level_params[] =
{
  {LVL_IMMORT, "&+GGuest&n"},
  {LVL_GOD1, "&+CTrainees&n"},
  {LVL_GOD2, "&+LLesser &+BBuilders&n"},
  {LVL_GOD3, "&+LLesser &+RCoder&n"},
  {LVL_GOD4, "&+LGreater &+BBuilders&n"},
  {LVL_GOD5, "&+LGreater &+RCoder&n"},
  {LVL_GOD6, "&+LSenior &+BBuilders&n"},
  {LVL_GOD7, "&+LSenior &+RCoder&n"},
  {LVL_GRGOD, "&+LAssistant Dungeon Masters&n"},
  {LVL_IMPL, "&+LCreators of the &+rWorld&n"},
  {0, ""}
};


struct level_rec *levels = 0;


char *strip_color(const char *string)
{
  static char colorless[1024];
  int x, y = 0;

  for (x = 0; x <= strlen(string); x++) {
    if (string[x] == '&') {
      if (string[x + 1] == '+') {
	colorless[y++] = string[x + 3];
	x += 3;
      } else {
	colorless[y++] = string[x + 2];
	x += 2;
      }
    } else {
      colorless[y++] = string[x];
    }
  }
  return colorless;
}

void initialize(void)
{
  struct level_rec *tmp;
  int i = 0;
  while (level_params[i].level > 0) {
    tmp = (struct level_rec *) malloc(sizeof(struct level_rec));
    tmp->names = 0;
    tmp->params = &(level_params[i++]);
    tmp->next = levels;
    levels = tmp;
  }
}


void read_file(void)
{
  void add_name(byte level, char *name, char *title);

  struct char_file_u player;
  FILE *fl;

  if (!(fl = fopen(PLAYER_FILE, "rb"))) {
    perror("Error opening playerfile");
    exit(1);
  }
  while (!feof(fl)) {
    if (fread(&player, sizeof(struct char_file_u), 1, fl) == 1)
    if (!feof(fl) && player.level >= MIN_LEVEL &&
	!(IS_SET(player.char_specials_saved.act, PLR_FROZEN)) &&
	!(IS_SET(player.char_specials_saved.act, PLR_NOWIZLIST)) &&
	!(IS_SET(player.char_specials_saved.act, PLR_DELETED))) 
       add_name(player.level, player.name, player.title);
/*    else
      printf("reject: %s\n", player.name); */
  }

  fclose(fl);
}


void add_name(byte level, char *name, char *title)
{
  struct name_rec *tmp;
  struct level_rec *curr_level;
  char *ptr;

  if (!name || !*name)
    return;
  
  
  for (ptr = name; *ptr; ptr++)
    if (!isalpha(*ptr))
      return;

  tmp = (struct name_rec *) malloc(sizeof(struct name_rec));
  if (!strcmp(name, "Istus"))
     strcpy(tmp->name, "&+CIstus&n");
  else if (!strcmp(name, "Tastone"))
     strcpy(tmp->name, "&+RTa&+rsto&+Rne&n");
  else
     strcpy(tmp->name, name);
  if (title)
    strcpy(tmp->title, title);
  else
     strcpy(tmp->title, ""); 
    tmp->next = 0; 

  curr_level = levels;
  while (curr_level->params->level > level)
    curr_level = curr_level->next;

  tmp->next = curr_level->names;
  curr_level->names = tmp; 
}


void sort_names(void)
{
  struct level_rec *curr_level;
  struct name_rec *a, *b;
  char temp[100];
  char temp1[100];
  
  for (curr_level = levels; curr_level; curr_level = curr_level->next) {
    for (a = curr_level->names; a && a->next; a = a->next) {
      for (b = a->next; b; b = b->next) {
	if (strcmp(a->name, b->name) > 0) {
	  strcpy(temp, a->name);
	  strcpy(temp1, a->title);
	  strcpy(a->name, b->name);
	  strcpy(a->title, b->title);
	  strcpy(b->name, temp);
	  strcpy(b->title, temp1);
	}
      }
    }
  }
}


void write_wizlist(FILE * out, int minlev, int maxlev)
{
  char buf[100];
  char buf1[100];
  struct level_rec *curr_level;
  struct name_rec *curr_name;
  int i, j, StrLen=0;

  fprintf(out,                   
"                            &+W/&+L----------------------&+W\\&n           \n"
"                            &+L|      &+WG&+LREY &+WH&+LAWK       &+L|&n             \n"
"                            &+L|                      &+L|&n             \n"
"                            &+L|      &n&+gADV&+GENT&n&+gURES      &+L|&n             \n"
"                            &+W\\&+L----------------------&+W/&n           \n"
"                             &+r-&+R*&n&+r- IM&+RMORT&n&+rAL  L&+RI&n&+rST -&+R*&n&+r-            \n\n");

  for (curr_level = levels; curr_level; curr_level = curr_level->next) {
    if (curr_level->params->level < minlev ||
	curr_level->params->level > maxlev)
      continue;
    strcpy(buf1, strip_color(curr_level->params->level_name));
    i = 40 - (strlen(buf1) >> 1);
    for (j = 1; j <= i; j++)
      fputc(' ', out);
    fprintf(out, "%s\n", curr_level->params->level_name);
    for (j = 1; j <= i; j++)
      fputc(' ', out);
    for (j = 1; j <= strlen(buf1); j++)
      fputc('~', out);
    fprintf(out, "\n");

    strcpy(buf, "");
    curr_name = curr_level->names;
    while (curr_name) {
      strcat(buf, curr_name->name);
      strcat(buf, " ");
      strcat(buf, curr_name->title);

      strcpy(buf1, strip_color(curr_name->title));
      StrLen = strlen(buf1) + 1 + strlen(curr_name->name);

      if (StrLen > LINE_LEN) {
	if (curr_level->params->level <= COL_LEVEL)
	  fprintf(out, IMM_LMARG);
	else {
	  i = 40 - (StrLen >> 1);
	  for (j = 1; j <= i; j++)
	    fputc(' ', out);
	}
	fprintf(out, "%s\n", buf);
	strcpy(buf, "");
      } else {
	if (curr_level->params->level <= COL_LEVEL) {
	  for (j = 1; j <= (IMM_NSIZE - StrLen); j++)
	    strcat(buf, " ");
	}
	if (curr_level->params->level > COL_LEVEL)
	  strcat(buf, "   ");
      }
      curr_name = curr_name->next;
    }

    if (*buf) {
      if (curr_level->params->level <= COL_LEVEL)
	fprintf(out, "%s%s\n", IMM_LMARG, buf);
      else {
	i = 40 - (StrLen >> 1);
	for (j = 1; j <= i; j++)
	  fputc(' ', out);
	fprintf(out, "%s\n", buf);
      }
    }
    fprintf(out, "\n");
  }
}




int main(int argc, char **argv)
{
  int wizlevel, immlevel, pid = 0;
  FILE *fl;

  if (argc != 5 && argc != 6) {
    printf("Format: %s wizlev wizlistfile immlev immlistfile [pid to signal]\n",
	   argv[0]);
    exit(0);
  }
  wizlevel = atoi(argv[1]);
  immlevel = atoi(argv[3]);
  if (argc == 6)
    pid = atoi(argv[5]);
  initialize();
  read_file();
/*  sort_names();*/
  fl = fopen(argv[2], "w");
  write_wizlist(fl, wizlevel, LVL_IMPL);
  fclose(fl);
  fl = fopen(argv[4], "w");
  write_wizlist(fl, immlevel, wizlevel - 1);
  fclose(fl);
  if (pid)
    kill(pid, SIGUSR1);
  return 0;
}
